#line 1 "ad_aarch64_gen.cpp"
//
// Copyright (c) 2003, 2022, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2022, Red Hat, Inc. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/rootnode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode){

  switch(opcode) {
  case UNIVERSE:
    return new UniverseOper( );
  case LABEL:
    return new labelOper( );
  case SREGI:
    return new sRegIOper( );
  case SREGP:
    return new sRegPOper( );
  case SREGF:
    return new sRegFOper( );
  case SREGD:
    return new sRegDOper( );
  case SREGL:
    return new sRegLOper( );
  case METHOD:
    return new methodOper( );
  case IMMI:
    return new immIOper(_leaf->get_int() );
  case IMMI0:
    return new immI0Oper(_leaf->get_int() );
  case IMMI_1:
    return new immI_1Oper(_leaf->get_int() );
  case IMMI_M1:
    return new immI_M1Oper(_leaf->get_int() );
  case IMMIEXT:
    return new immIExtOper(_leaf->get_int() );
  case IMMI_LE_4:
    return new immI_le_4Oper(_leaf->get_int() );
  case IMMI_31:
    return new immI_31Oper(_leaf->get_int() );
  case IMMI_8:
    return new immI_8Oper(_leaf->get_int() );
  case IMMI_16:
    return new immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new immI_24Oper(_leaf->get_int() );
  case IMMI_32:
    return new immI_32Oper(_leaf->get_int() );
  case IMMI_48:
    return new immI_48Oper(_leaf->get_int() );
  case IMMI_56:
    return new immI_56Oper(_leaf->get_int() );
  case IMMI_63:
    return new immI_63Oper(_leaf->get_int() );
  case IMMI_64:
    return new immI_64Oper(_leaf->get_int() );
  case IMMI_255:
    return new immI_255Oper(_leaf->get_int() );
  case IMMI_65535:
    return new immI_65535Oper(_leaf->get_int() );
  case IMML_255:
    return new immL_255Oper(_leaf->get_long() );
  case IMML_65535:
    return new immL_65535Oper(_leaf->get_long() );
  case IMML_4294967295:
    return new immL_4294967295Oper(_leaf->get_long() );
  case IMML_BITMASK:
    return new immL_bitmaskOper(_leaf->get_long() );
  case IMMI_BITMASK:
    return new immI_bitmaskOper(_leaf->get_int() );
  case IMML_POSITIVE_BITMASKI:
    return new immL_positive_bitmaskIOper(_leaf->get_long() );
  case IMMISCALE:
    return new immIScaleOper(_leaf->get_int() );
  case IMMI26:
    return new immI26Oper(_leaf->get_int() );
  case IMMI19:
    return new immI19Oper(_leaf->get_int() );
  case IMMIU12:
    return new immIU12Oper(_leaf->get_int() );
  case IMMLU12:
    return new immLU12Oper(_leaf->get_long() );
  case IMMIOFFSET:
    return new immIOffsetOper(_leaf->get_int() );
  case IMMIOFFSET4:
    return new immIOffset4Oper(_leaf->get_int() );
  case IMMIOFFSET8:
    return new immIOffset8Oper(_leaf->get_int() );
  case IMMIOFFSET16:
    return new immIOffset16Oper(_leaf->get_int() );
  case IMMLOFFSET:
    return new immLoffsetOper(_leaf->get_long() );
  case IMMLOFFSET4:
    return new immLoffset4Oper(_leaf->get_long() );
  case IMMLOFFSET8:
    return new immLoffset8Oper(_leaf->get_long() );
  case IMMLOFFSET16:
    return new immLoffset16Oper(_leaf->get_long() );
  case IMMIADDSUB:
    return new immIAddSubOper(_leaf->get_int() );
  case IMMILOG:
    return new immILogOper(_leaf->get_int() );
  case IMML:
    return new immLOper(_leaf->get_long() );
  case IMML0:
    return new immL0Oper(_leaf->get_long() );
  case IMML_1:
    return new immL_1Oper(_leaf->get_long() );
  case IMML_M1:
    return new immL_M1Oper(_leaf->get_long() );
  case IMML_PC_OFF:
    return new immL_pc_offOper(_leaf->get_long() );
  case IMMLADDSUB:
    return new immLAddSubOper(_leaf->get_long() );
  case IMMLLOG:
    return new immLLogOper(_leaf->get_long() );
  case IMML_32BITS:
    return new immL_32bitsOper(_leaf->get_long() );
  case IMMP:
    return new immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP0:
    return new immP0Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_1:
    return new immP_1Oper(_leaf->bottom_type()->is_ptr() );
  case IMMPOLLPAGE:
    return new immPollPageOper(_leaf->bottom_type()->is_ptr() );
  case IMMBYTEMAPBASE:
    return new immByteMapBaseOper(_leaf->bottom_type()->is_ptr() );
  case IMMP_M1:
    return new immP_M1Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_M2:
    return new immP_M2Oper(_leaf->bottom_type()->is_ptr() );
  case IMMD:
    return new immDOper(_leaf->getd() );
  case IMMD0:
    return new immD0Oper(_leaf->getd() );
  case IMMDPACKED:
    return new immDPackedOper(_leaf->getd() );
  case IMMF:
    return new immFOper(_leaf->getf() );
  case IMMF0:
    return new immF0Oper(_leaf->getf() );
  case IMMFPACKED:
    return new immFPackedOper(_leaf->getf() );
  case IMMI_POSITIVE:
    return new immI_positiveOper(_leaf->get_int() );
  case IMMN:
    return new immNOper(_leaf->bottom_type()->is_narrowoop() );
  case IMMN0:
    return new immN0Oper(_leaf->bottom_type()->is_narrowoop() );
  case IMMNKLASS:
    return new immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
  case IREGI:
    return new iRegIOper( );
  case IREGINOSP:
    return new iRegINoSpOper( );
  case IREGL:
    return new iRegLOper( );
  case IREGLNOSP:
    return new iRegLNoSpOper( );
  case IREGP:
    return new iRegPOper( );
  case IREGPNOSP:
    return new iRegPNoSpOper( );
  case IREGP_R0:
    return new iRegP_R0Oper( );
  case IREGP_R1:
    return new iRegP_R1Oper( );
  case IREGP_R2:
    return new iRegP_R2Oper( );
  case IREGP_R3:
    return new iRegP_R3Oper( );
  case IREGP_R4:
    return new iRegP_R4Oper( );
  case IREGP_R5:
    return new iRegP_R5Oper( );
  case IREGP_R10:
    return new iRegP_R10Oper( );
  case IREGL_R0:
    return new iRegL_R0Oper( );
  case IREGL_R2:
    return new iRegL_R2Oper( );
  case IREGL_R3:
    return new iRegL_R3Oper( );
  case IREGL_R11:
    return new iRegL_R11Oper( );
  case IREGP_FP:
    return new iRegP_FPOper( );
  case IREGI_R0:
    return new iRegI_R0Oper( );
  case IREGI_R2:
    return new iRegI_R2Oper( );
  case IREGI_R3:
    return new iRegI_R3Oper( );
  case IREGI_R4:
    return new iRegI_R4Oper( );
  case IREGN:
    return new iRegNOper( );
  case IREGN_R0:
    return new iRegN_R0Oper( );
  case IREGN_R2:
    return new iRegN_R2Oper( );
  case IREGN_R3:
    return new iRegN_R3Oper( );
  case IREGNNOSP:
    return new iRegNNoSpOper( );
  case IREGIHEAPBASE:
    return new iRegIHeapbaseOper( );
  case VREGF:
    return new vRegFOper( );
  case VREGD:
    return new vRegDOper( );
  case VECD:
    return new vecDOper( );
  case VECX:
    return new vecXOper( );
  case VREGD_V0:
    return new vRegD_V0Oper( );
  case VREGD_V1:
    return new vRegD_V1Oper( );
  case VREGD_V2:
    return new vRegD_V2Oper( );
  case VREGD_V3:
    return new vRegD_V3Oper( );
  case VREGD_V4:
    return new vRegD_V4Oper( );
  case VREGD_V5:
    return new vRegD_V5Oper( );
  case VREGD_V6:
    return new vRegD_V6Oper( );
  case VREGD_V7:
    return new vRegD_V7Oper( );
  case RFLAGSREG:
    return new rFlagsRegOper( );
  case RFLAGSREGU:
    return new rFlagsRegUOper( );
  case INLINE_CACHE_REGP:
    return new inline_cache_RegPOper( );
  case INTERPRETER_METHOD_OOP_REGP:
    return new interpreter_method_oop_RegPOper( );
  case THREAD_REGP:
    return new thread_RegPOper( );
  case LR_REGP:
    return new lr_RegPOper( );
  case INDIRECT:
    return new indirectOper( );
  case INDINDEXSCALEDI2L:
    return new indIndexScaledI2LOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALED:
    return new indIndexScaledOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXI2L:
    return new indIndexI2LOper( );
  case INDINDEX:
    return new indIndexOper( );
  case INDOFFI:
    return new indOffIOper(_kids[1]->_leaf->get_int() );
  case INDOFFI4:
    return new indOffI4Oper(_kids[1]->_leaf->get_int() );
  case INDOFFI8:
    return new indOffI8Oper(_kids[1]->_leaf->get_int() );
  case INDOFFI16:
    return new indOffI16Oper(_kids[1]->_leaf->get_int() );
  case INDOFFL:
    return new indOffLOper(_kids[1]->_leaf->get_long() );
  case INDOFFL4:
    return new indOffL4Oper(_kids[1]->_leaf->get_long() );
  case INDOFFL8:
    return new indOffL8Oper(_kids[1]->_leaf->get_long() );
  case INDOFFL16:
    return new indOffL16Oper(_kids[1]->_leaf->get_long() );
  case INDIRECTN:
    return new indirectNOper( );
  case INDINDEXSCALEDI2LN:
    return new indIndexScaledI2LNOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALEDN:
    return new indIndexScaledNOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXI2LN:
    return new indIndexI2LNOper( );
  case INDINDEXN:
    return new indIndexNOper( );
  case INDOFFIN:
    return new indOffINOper(_kids[1]->_leaf->get_int() );
  case INDOFFLN:
    return new indOffLNOper(_kids[1]->_leaf->get_long() );
  case THREAD_ANCHOR_PC:
    return new thread_anchor_pcOper(_kids[1]->_leaf->get_long() );
  case STACKSLOTP:
    return new stackSlotPOper( );
  case STACKSLOTI:
    return new stackSlotIOper( );
  case STACKSLOTF:
    return new stackSlotFOper( );
  case STACKSLOTD:
    return new stackSlotDOper( );
  case STACKSLOTL:
    return new stackSlotLOper( );
  case CMPOP:
    return new cmpOpOper(_leaf->as_Bool()->_test._test );
  case CMPOPU:
    return new cmpOpUOper(_leaf->as_Bool()->_test._test );
  case CMPOPEQNE:
    return new cmpOpEqNeOper(_leaf->as_Bool()->_test._test );
  case CMPOPLTGE:
    return new cmpOpLtGeOper(_leaf->as_Bool()->_test._test );
  case CMPOPUEQNELTGE:
    return new cmpOpUEqNeLtGeOper(_leaf->as_Bool()->_test._test );
  case IREGL2I:
    return new iRegL2IOper( );
  case _CONVI2L_IREGI_:    return NULL;
  case _LSHIFTL__CONVI2L_IREGI__IMMISCALE:    return NULL;
  case _LSHIFTL_IREGL_IMMISCALE:    return NULL;
  case _DECODEN_IREGN_:    return NULL;
  case _LOADB_MEMORY_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _LOADS_MEMORY_:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  case _LOADB_INDIRECT_:    return NULL;
  case _LOADUB_INDIRECT_:    return NULL;
  case _LOADUS_INDIRECT_:    return NULL;
  case _LOADS_INDIRECT_:    return NULL;
  case _LOADI_INDIRECT_:    return NULL;
  case _CONVI2L__LOADI_INDIRECT__:    return NULL;
  case _LOADL_MEMORY_:    return NULL;
  case _CASTP2X_IREGP_:    return NULL;
  case _CASTP2X__DECODEN_IREGN__:    return NULL;
  case _BINARY_IREGP_IREGP:    return NULL;
  case _BINARY_IREGLNOSP_IREGLNOSP:    return NULL;
  case _BINARY_IREGINOSP_IREGINOSP:    return NULL;
  case _BINARY_IREGNNOSP_IREGNNOSP:    return NULL;
  case _BINARY_IREGI_IREGI:    return NULL;
  case _BINARY_IREGL_IREGL:    return NULL;
  case _BINARY_IREGN_IREGN:    return NULL;
  case _BINARY_CMPOP_RFLAGSREG:    return NULL;
  case _BINARY_IREGIORL2I_IREGIORL2I:    return NULL;
  case _BINARY_CMPOPU_RFLAGSREGU:    return NULL;
  case _BINARY_IMMI0_IREGIORL2I:    return NULL;
  case _BINARY_IREGIORL2I_IMMI0:    return NULL;
  case _BINARY_IMMI_1_IMMI0:    return NULL;
  case _BINARY_IREGL_IMML0:    return NULL;
  case _BINARY_IMML0_IREGL:    return NULL;
  case _BINARY_IREGP_IMMP0:    return NULL;
  case _BINARY_IMMP0_IREGP:    return NULL;
  case _BINARY_IREGN_IMMN0:    return NULL;
  case _BINARY_IMMN0_IREGN:    return NULL;
  case _BINARY_VREGF_VREGF:    return NULL;
  case _BINARY_VREGD_VREGD:    return NULL;
  case _CONVL2I_IREGL_:    return NULL;
  case _CONVI2L_IREGIORL2I_:    return NULL;
  case _LSHIFTL__CONVI2L_IREGIORL2I__IMMISCALE:    return NULL;
  case _MULI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _MULL_IREGL_IREGL:    return NULL;
  case _MULL__CONVI2L_IREGIORL2I___CONVI2L_IREGIORL2I_:    return NULL;
  case _SUBL_IMML0__CONVI2L_IREGIORL2I_:    return NULL;
  case _XORI_IREGIORL2I_IMMI_M1:    return NULL;
  case _XORL_IREGL_IMML_M1:    return NULL;
  case _XORI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _XORL_IREGL_IREGL:    return NULL;
  case _URSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORI__URSHIFTI_IREGIORL2I_IMMI_IMMI_M1:    return NULL;
  case _URSHIFTL_IREGL_IMMI:    return NULL;
  case _XORL__URSHIFTL_IREGL_IMMI_IMML_M1:    return NULL;
  case _RSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORI__RSHIFTI_IREGIORL2I_IMMI_IMMI_M1:    return NULL;
  case _RSHIFTL_IREGL_IMMI:    return NULL;
  case _XORL__RSHIFTL_IREGL_IMMI_IMML_M1:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORI__LSHIFTI_IREGIORL2I_IMMI_IMMI_M1:    return NULL;
  case _LSHIFTL_IREGL_IMMI:    return NULL;
  case _XORL__LSHIFTL_IREGL_IMMI_IMML_M1:    return NULL;
  case _XORI__URSHIFTI_IREGIORL2I_IMMI_IREGIORL2I:    return NULL;
  case _XORI_IREGIORL2I__URSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORL__URSHIFTL_IREGL_IMMI_IREGL:    return NULL;
  case _XORL_IREGL__URSHIFTL_IREGL_IMMI:    return NULL;
  case _XORI__RSHIFTI_IREGIORL2I_IMMI_IREGIORL2I:    return NULL;
  case _XORI_IREGIORL2I__RSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORL__RSHIFTL_IREGL_IMMI_IREGL:    return NULL;
  case _XORL_IREGL__RSHIFTL_IREGL_IMMI:    return NULL;
  case _XORI__LSHIFTI_IREGIORL2I_IMMI_IREGIORL2I:    return NULL;
  case _XORI_IREGIORL2I__LSHIFTI_IREGIORL2I_IMMI:    return NULL;
  case _XORL__LSHIFTL_IREGL_IMMI_IREGL:    return NULL;
  case _XORL_IREGL__LSHIFTL_IREGL_IMMI:    return NULL;
  case _ANDI__URSHIFTI_IREGIORL2I_IMMI_IMMI_BITMASK:    return NULL;
  case _ANDI_IREGIORL2I_IMMI_BITMASK:    return NULL;
  case _ANDL_IREGL_IMML_BITMASK:    return NULL;
  case _LSHIFTI__ANDI_IREGIORL2I_IMMI_BITMASK_IMMI:    return NULL;
  case _ANDL_IREGL_IMML_POSITIVE_BITMASKI:    return NULL;
  case _LSHIFTL__ANDL_IREGL_IMML_POSITIVE_BITMASKI_IMMI:    return NULL;
  case _CONVI2L__ANDI_IREGIORL2I_IMMI_BITMASK_:    return NULL;
  case _CONVL2I__ANDL_IREGL_IMML_POSITIVE_BITMASKI_:    return NULL;
  case _ANDI_IREGI_IMMI_BITMASK:    return NULL;
  case _LSHIFTL_IREGL_IREGI:    return NULL;
  case _SUBI_IMMI_64_IREGI:    return NULL;
  case _URSHIFTL_IREGL__SUBI_IMMI_64_IREGI:    return NULL;
  case _SUBI_IMMI0_IREGI:    return NULL;
  case _URSHIFTL_IREGL__SUBI_IMMI0_IREGI:    return NULL;
  case _LSHIFTI_IREGI_IREGI:    return NULL;
  case _SUBI_IMMI_32_IREGI:    return NULL;
  case _URSHIFTI_IREGI__SUBI_IMMI_32_IREGI:    return NULL;
  case _URSHIFTI_IREGI__SUBI_IMMI0_IREGI:    return NULL;
  case _URSHIFTL_IREGL_IREGI:    return NULL;
  case _LSHIFTL_IREGL__SUBI_IMMI_64_IREGI:    return NULL;
  case _LSHIFTL_IREGL__SUBI_IMMI0_IREGI:    return NULL;
  case _URSHIFTI_IREGI_IREGI:    return NULL;
  case _LSHIFTI_IREGI__SUBI_IMMI_32_IREGI:    return NULL;
  case _LSHIFTI_IREGI__SUBI_IMMI0_IREGI:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI_16:    return NULL;
  case _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI_24:    return NULL;
  case _RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24:    return NULL;
  case _URSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24:    return NULL;
  case _LSHIFTL_IREGL_IMMI_48:    return NULL;
  case _RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48:    return NULL;
  case _LSHIFTL_IREGL_IMMI_32:    return NULL;
  case _RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32:    return NULL;
  case _LSHIFTL_IREGL_IMMI_56:    return NULL;
  case _RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56:    return NULL;
  case _URSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56:    return NULL;
  case _ANDI_IREGIORL2I_IMMI_255:    return NULL;
  case _ANDI_IREGIORL2I_IMMI_65535:    return NULL;
  case _ANDL_IREGL_IMML_255:    return NULL;
  case _ANDL_IREGL_IMML_65535:    return NULL;
  case _ANDL_IREGL_IMML_4294967295:    return NULL;
  case _LSHIFTL__RSHIFTL__LSHIFTL_IREGL_IMMI_56_IMMI_56_IMMIEXT:    return NULL;
  case _LSHIFTL__RSHIFTL__LSHIFTL_IREGL_IMMI_48_IMMI_48_IMMIEXT:    return NULL;
  case _LSHIFTL__RSHIFTL__LSHIFTL_IREGL_IMMI_32_IMMI_32_IMMIEXT:    return NULL;
  case _LSHIFTI__RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_24_IMMI_24_IMMIEXT:    return NULL;
  case _LSHIFTI__RSHIFTI__LSHIFTI_IREGIORL2I_IMMI_16_IMMI_16_IMMIEXT:    return NULL;
  case _LSHIFTL__CONVI2L_IREGIORL2I__IMMIEXT:    return NULL;
  case _LSHIFTL__ANDL_IREGL_IMML_255_IMMIEXT:    return NULL;
  case _LSHIFTL__ANDL_IREGL_IMML_65535_IMMIEXT:    return NULL;
  case _LSHIFTL__ANDL_IREGL_IMML_4294967295_IMMIEXT:    return NULL;
  case _LSHIFTI__ANDI_IREGIORL2I_IMMI_255_IMMIEXT:    return NULL;
  case _LSHIFTI__ANDI_IREGIORL2I_IMMI_65535_IMMIEXT:    return NULL;
  case _NEGF_VREGF_:    return NULL;
  case _BINARY__NEGF_VREGF__VREGF:    return NULL;
  case _BINARY_VREGF__NEGF_VREGF_:    return NULL;
  case _NEGD_VREGD_:    return NULL;
  case _BINARY__NEGD_VREGD__VREGD:    return NULL;
  case _BINARY_VREGD__NEGD_VREGD_:    return NULL;
  case _OVERFLOWMULI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _OVERFLOWMULL_IREGL_IREGL:    return NULL;
  case _CMPI_IREGIORL2I_IMMI0:    return NULL;
  case _CMPL_IREGL_IMML0:    return NULL;
  case _CMPP_IREGP_IMMP0:    return NULL;
  case _CMPN_IREGN_IMMN0:    return NULL;
  case _CMPP__DECODEN_IREGN__IMMP0:    return NULL;
  case _CMPU_IREGIORL2I_IMMI0:    return NULL;
  case _CMPUL_IREGL_IMML0:    return NULL;
  case _ANDL_IREGL_IMML:    return NULL;
  case _CMPL__ANDL_IREGL_IMML_IMML0:    return NULL;
  case _ANDI_IREGIORL2I_IMMI:    return NULL;
  case _CMPI__ANDI_IREGIORL2I_IMMI_IMMI0:    return NULL;
  case _ANDL_IREGL_IREGL:    return NULL;
  case _ANDI_IREGIORL2I_IREGIORL2I:    return NULL;
  case _PARTIALSUBTYPECHECK_IREGP_R4_IREGP_R0:    return NULL;
  case _BINARY_IREGP_R1_IREGI_R2:    return NULL;
  case _BINARY_IREGP_R3_IREGI_R4:    return NULL;
  case _BINARY_IREGP_R1_IREGI_R4:    return NULL;
  case _BINARY_IREGP_R3_IREGI_R2:    return NULL;
  case _BINARY_IREGP_R3_IMMI_LE_4:    return NULL;
  case _BINARY_IREGP_R3_IMMI_1:    return NULL;
  case _BINARY_IREGP_R1_IREGP_R3:    return NULL;
  case _BINARY_IREGP_R1_IREGI_R3:    return NULL;
  case _MULVS_VECD_VECD:    return NULL;
  case _MULVS_VECX_VECX:    return NULL;
  case _MULVI_VECD_VECD:    return NULL;
  case _MULVI_VECX_VECX:    return NULL;
  case _BINARY_VECD_VECD:    return NULL;
  case _BINARY_VECX_VECX:    return NULL;
  case _NEGVF_VECD_:    return NULL;
  case _BINARY__NEGVF_VECD__VECD:    return NULL;
  case _BINARY_VECD__NEGVF_VECD_:    return NULL;
  case _NEGVF_VECX_:    return NULL;
  case _BINARY__NEGVF_VECX__VECX:    return NULL;
  case _BINARY_VECX__NEGVF_VECX_:    return NULL;
  case _NEGVD_VECX_:    return NULL;
  case _BINARY__NEGVD_VECX__VECX:    return NULL;
  case _BINARY_VECX__NEGVD_VECX_:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode){
  switch(opcode) {
  case loadB_rule: {
      loadBNode *node = new loadBNode();
      return node;
    }
  case loadB2L_rule: {
      loadB2LNode *node = new loadB2LNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new loadUBNode();
      return node;
    }
  case loadUB2L_rule: {
      loadUB2LNode *node = new loadUB2LNode();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new loadSNode();
      return node;
    }
  case loadS2L_rule: {
      loadS2LNode *node = new loadS2LNode();
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new loadUSNode();
      return node;
    }
  case loadUS2L_rule: {
      loadUS2LNode *node = new loadUS2LNode();
      return node;
    }
  case loadI_rule: {
      loadINode *node = new loadINode();
      return node;
    }
  case loadI2L_rule: {
      loadI2LNode *node = new loadI2LNode();
      return node;
    }
  case loadUI2L_rule: {
      loadUI2LNode *node = new loadUI2LNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new loadLNode();
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new loadRangeNode();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_rule: {
      loadNNode *node = new loadNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadNKlass_rule: {
      loadNKlassNode *node = new loadNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new loadFNode();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new loadDNode();
      return node;
    }
  case loadConI_rule: {
      loadConINode *node = new loadConINode();
      node->_opnd_array[1] = new immIOper(_leaf->get_int() );
      return node;
    }
  case loadConL_rule: {
      loadConLNode *node = new loadConLNode();
      node->_opnd_array[1] = new immLOper(_leaf->get_long() );
      return node;
    }
  case loadConP_rule: {
      loadConPNode *node = new loadConPNode();
      node->_opnd_array[1] = new immPOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP0_rule: {
      loadConP0Node *node = new loadConP0Node();
      node->_opnd_array[1] = new immP0Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP1_rule: {
      loadConP1Node *node = new loadConP1Node();
      node->_opnd_array[1] = new immP_1Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConPollPage_rule: {
      loadConPollPageNode *node = new loadConPollPageNode();
      node->_opnd_array[1] = new immPollPageOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadByteMapBase_rule: {
      loadByteMapBaseNode *node = new loadByteMapBaseNode();
      node->_opnd_array[1] = new immByteMapBaseOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConN_rule: {
      loadConNNode *node = new loadConNNode();
      node->_opnd_array[1] = new immNOper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConN0_rule: {
      loadConN0Node *node = new loadConN0Node();
      node->_opnd_array[1] = new immN0Oper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConNKlass_rule: {
      loadConNKlassNode *node = new loadConNKlassNode();
      node->_opnd_array[1] = new immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
      return node;
    }
  case loadConF_packed_rule: {
      loadConF_packedNode *node = new loadConF_packedNode();
      node->_opnd_array[1] = new immFPackedOper(_leaf->getf() );
      return node;
    }
  case loadConF_rule: {
      loadConFNode *node = new loadConFNode();
      node->_opnd_array[1] = new immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD_packed_rule: {
      loadConD_packedNode *node = new loadConD_packedNode();
      node->_opnd_array[1] = new immDPackedOper(_leaf->getd() );
      return node;
    }
  case loadConD_rule: {
      loadConDNode *node = new loadConDNode();
      node->_opnd_array[1] = new immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmCM0_rule: {
      storeimmCM0Node *node = new storeimmCM0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmCM0_ordered_rule: {
      storeimmCM0_orderedNode *node = new storeimmCM0_orderedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmB0_rule: {
      storeimmB0Node *node = new storeimmB0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmC0_rule: {
      storeimmC0Node *node = new storeimmC0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmI0_rule: {
      storeimmI0Node *node = new storeimmI0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_rule: {
      storeLNode *node = new storeLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmL0_rule: {
      storeimmL0Node *node = new storeimmL0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmP0_rule: {
      storeimmP0Node *node = new storeimmP0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_rule: {
      storeNNode *node = new storeNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmN0_rule: {
      storeImmN0Node *node = new storeImmN0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_rule: {
      storeFNode *node = new storeFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_rule: {
      storeDNode *node = new storeDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeNKlass_rule: {
      storeNKlassNode *node = new storeNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case prefetchalloc_rule: {
      prefetchallocNode *node = new prefetchallocNode();
      return node;
    }
  case loadB_volatile_rule: {
      loadB_volatileNode *node = new loadB_volatileNode();
      return node;
    }
  case loadB2L_volatile_rule: {
      loadB2L_volatileNode *node = new loadB2L_volatileNode();
      return node;
    }
  case loadUB_volatile_rule: {
      loadUB_volatileNode *node = new loadUB_volatileNode();
      return node;
    }
  case loadUB2L_volatile_rule: {
      loadUB2L_volatileNode *node = new loadUB2L_volatileNode();
      return node;
    }
  case loadS_volatile_rule: {
      loadS_volatileNode *node = new loadS_volatileNode();
      return node;
    }
  case loadUS_volatile_rule: {
      loadUS_volatileNode *node = new loadUS_volatileNode();
      return node;
    }
  case loadUS2L_volatile_rule: {
      loadUS2L_volatileNode *node = new loadUS2L_volatileNode();
      return node;
    }
  case loadS2L_volatile_rule: {
      loadS2L_volatileNode *node = new loadS2L_volatileNode();
      return node;
    }
  case loadI_volatile_rule: {
      loadI_volatileNode *node = new loadI_volatileNode();
      return node;
    }
  case loadUI2L_volatile_rule: {
      loadUI2L_volatileNode *node = new loadUI2L_volatileNode();
      return node;
    }
  case loadL_volatile_rule: {
      loadL_volatileNode *node = new loadL_volatileNode();
      return node;
    }
  case loadP_volatile_rule: {
      loadP_volatileNode *node = new loadP_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_volatile_rule: {
      loadN_volatileNode *node = new loadN_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_volatile_rule: {
      loadF_volatileNode *node = new loadF_volatileNode();
      return node;
    }
  case loadD_volatile_rule: {
      loadD_volatileNode *node = new loadD_volatileNode();
      return node;
    }
  case storeB_volatile_rule: {
      storeB_volatileNode *node = new storeB_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_volatile_rule: {
      storeC_volatileNode *node = new storeC_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_volatile_rule: {
      storeI_volatileNode *node = new storeI_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_volatile_rule: {
      storeL_volatileNode *node = new storeL_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_volatile_rule: {
      storeP_volatileNode *node = new storeP_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_volatile_rule: {
      storeN_volatileNode *node = new storeN_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_volatile_rule: {
      storeF_volatileNode *node = new storeF_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_volatile_rule: {
      storeD_volatileNode *node = new storeD_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case bytes_reverse_int_rule: {
      bytes_reverse_intNode *node = new bytes_reverse_intNode();
      return node;
    }
  case bytes_reverse_long_rule: {
      bytes_reverse_longNode *node = new bytes_reverse_longNode();
      return node;
    }
  case bytes_reverse_unsigned_short_rule: {
      bytes_reverse_unsigned_shortNode *node = new bytes_reverse_unsigned_shortNode();
      return node;
    }
  case bytes_reverse_short_rule: {
      bytes_reverse_shortNode *node = new bytes_reverse_shortNode();
      return node;
    }
  case countLeadingZerosI_rule: {
      countLeadingZerosINode *node = new countLeadingZerosINode();
      return node;
    }
  case countLeadingZerosL_rule: {
      countLeadingZerosLNode *node = new countLeadingZerosLNode();
      return node;
    }
  case countTrailingZerosI_rule: {
      countTrailingZerosINode *node = new countTrailingZerosINode();
      return node;
    }
  case countTrailingZerosL_rule: {
      countTrailingZerosLNode *node = new countTrailingZerosLNode();
      return node;
    }
  case popCountI_rule: {
      popCountINode *node = new popCountINode();
      node->set_opnd_array(2, MachOperGenerator(VREGF));
      return node;
    }
  case popCountI_mem_rule: {
      popCountI_memNode *node = new popCountI_memNode();
      node->set_opnd_array(2, MachOperGenerator(VREGF));
      return node;
    }
  case popCountL_rule: {
      popCountLNode *node = new popCountLNode();
      node->set_opnd_array(2, MachOperGenerator(VREGD));
      return node;
    }
  case popCountL_mem_rule: {
      popCountL_memNode *node = new popCountL_memNode();
      node->set_opnd_array(2, MachOperGenerator(VREGD));
      return node;
    }
  case load_fence_rule: {
      load_fenceNode *node = new load_fenceNode();
      return node;
    }
  case unnecessary_membar_acquire_rule: {
      unnecessary_membar_acquireNode *node = new unnecessary_membar_acquireNode();
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new membar_acquireNode();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new membar_acquire_lockNode();
      return node;
    }
  case store_fence_rule: {
      store_fenceNode *node = new store_fenceNode();
      return node;
    }
  case unnecessary_membar_release_rule: {
      unnecessary_membar_releaseNode *node = new unnecessary_membar_releaseNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new membar_releaseNode();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new membar_storestoreNode();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new membar_release_lockNode();
      return node;
    }
  case unnecessary_membar_volatile_rule: {
      unnecessary_membar_volatileNode *node = new unnecessary_membar_volatileNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new membar_volatileNode();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new castP2XNode();
      return node;
    }
  case convP2I_rule: {
      convP2INode *node = new convP2INode();
      return node;
    }
  case convN2I_rule: {
      convN2INode *node = new convN2INode();
      return node;
    }
  case encodeHeapOop_rule: {
      encodeHeapOopNode *node = new encodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeHeapOop_not_null_rule: {
      encodeHeapOop_not_nullNode *node = new encodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_rule: {
      decodeHeapOopNode *node = new decodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_not_null_rule: {
      decodeHeapOop_not_nullNode *node = new decodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeKlass_not_null_rule: {
      encodeKlass_not_nullNode *node = new encodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeKlass_not_null_rule: {
      decodeKlass_not_nullNode *node = new decodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new castIINode();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storePConditional_rule: {
      storePConditionalNode *node = new storePConditionalNode();
      return node;
    }
  case storeLConditional_rule: {
      storeLConditionalNode *node = new storeLConditionalNode();
      return node;
    }
  case storeIConditional_rule: {
      storeIConditionalNode *node = new storeIConditionalNode();
      return node;
    }
  case compareAndSwapB_rule: {
      compareAndSwapBNode *node = new compareAndSwapBNode();
      return node;
    }
  case compareAndSwapS_rule: {
      compareAndSwapSNode *node = new compareAndSwapSNode();
      return node;
    }
  case compareAndSwapI_rule: {
      compareAndSwapINode *node = new compareAndSwapINode();
      return node;
    }
  case compareAndSwapL_rule: {
      compareAndSwapLNode *node = new compareAndSwapLNode();
      return node;
    }
  case compareAndSwapP_rule: {
      compareAndSwapPNode *node = new compareAndSwapPNode();
      return node;
    }
  case compareAndSwapN_rule: {
      compareAndSwapNNode *node = new compareAndSwapNNode();
      return node;
    }
  case compareAndSwapBAcq_rule: {
      compareAndSwapBAcqNode *node = new compareAndSwapBAcqNode();
      return node;
    }
  case compareAndSwapSAcq_rule: {
      compareAndSwapSAcqNode *node = new compareAndSwapSAcqNode();
      return node;
    }
  case compareAndSwapIAcq_rule: {
      compareAndSwapIAcqNode *node = new compareAndSwapIAcqNode();
      return node;
    }
  case compareAndSwapLAcq_rule: {
      compareAndSwapLAcqNode *node = new compareAndSwapLAcqNode();
      return node;
    }
  case compareAndSwapPAcq_rule: {
      compareAndSwapPAcqNode *node = new compareAndSwapPAcqNode();
      return node;
    }
  case compareAndSwapNAcq_rule: {
      compareAndSwapNAcqNode *node = new compareAndSwapNAcqNode();
      return node;
    }
  case compareAndExchangeB_rule: {
      compareAndExchangeBNode *node = new compareAndExchangeBNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeS_rule: {
      compareAndExchangeSNode *node = new compareAndExchangeSNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeI_rule: {
      compareAndExchangeINode *node = new compareAndExchangeINode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeL_rule: {
      compareAndExchangeLNode *node = new compareAndExchangeLNode();
      node->set_opnd_array(4, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case compareAndExchangeN_rule: {
      compareAndExchangeNNode *node = new compareAndExchangeNNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeP_rule: {
      compareAndExchangePNode *node = new compareAndExchangePNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeBAcq_rule: {
      compareAndExchangeBAcqNode *node = new compareAndExchangeBAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeSAcq_rule: {
      compareAndExchangeSAcqNode *node = new compareAndExchangeSAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeIAcq_rule: {
      compareAndExchangeIAcqNode *node = new compareAndExchangeIAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeLAcq_rule: {
      compareAndExchangeLAcqNode *node = new compareAndExchangeLAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case compareAndExchangeNAcq_rule: {
      compareAndExchangeNAcqNode *node = new compareAndExchangeNAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangePAcq_rule: {
      compareAndExchangePAcqNode *node = new compareAndExchangePAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case weakCompareAndSwapB_rule: {
      weakCompareAndSwapBNode *node = new weakCompareAndSwapBNode();
      return node;
    }
  case weakCompareAndSwapS_rule: {
      weakCompareAndSwapSNode *node = new weakCompareAndSwapSNode();
      return node;
    }
  case weakCompareAndSwapI_rule: {
      weakCompareAndSwapINode *node = new weakCompareAndSwapINode();
      return node;
    }
  case weakCompareAndSwapL_rule: {
      weakCompareAndSwapLNode *node = new weakCompareAndSwapLNode();
      return node;
    }
  case weakCompareAndSwapN_rule: {
      weakCompareAndSwapNNode *node = new weakCompareAndSwapNNode();
      return node;
    }
  case weakCompareAndSwapP_rule: {
      weakCompareAndSwapPNode *node = new weakCompareAndSwapPNode();
      return node;
    }
  case weakCompareAndSwapBAcq_rule: {
      weakCompareAndSwapBAcqNode *node = new weakCompareAndSwapBAcqNode();
      return node;
    }
  case weakCompareAndSwapSAcq_rule: {
      weakCompareAndSwapSAcqNode *node = new weakCompareAndSwapSAcqNode();
      return node;
    }
  case weakCompareAndSwapIAcq_rule: {
      weakCompareAndSwapIAcqNode *node = new weakCompareAndSwapIAcqNode();
      return node;
    }
  case weakCompareAndSwapLAcq_rule: {
      weakCompareAndSwapLAcqNode *node = new weakCompareAndSwapLAcqNode();
      return node;
    }
  case weakCompareAndSwapNAcq_rule: {
      weakCompareAndSwapNAcqNode *node = new weakCompareAndSwapNAcqNode();
      return node;
    }
  case weakCompareAndSwapPAcq_rule: {
      weakCompareAndSwapPAcqNode *node = new weakCompareAndSwapPAcqNode();
      return node;
    }
  case get_and_setI_rule: {
      get_and_setINode *node = new get_and_setINode();
      return node;
    }
  case get_and_setL_rule: {
      get_and_setLNode *node = new get_and_setLNode();
      return node;
    }
  case get_and_setN_rule: {
      get_and_setNNode *node = new get_and_setNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setP_rule: {
      get_and_setPNode *node = new get_and_setPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setIAcq_rule: {
      get_and_setIAcqNode *node = new get_and_setIAcqNode();
      return node;
    }
  case get_and_setLAcq_rule: {
      get_and_setLAcqNode *node = new get_and_setLAcqNode();
      return node;
    }
  case get_and_setNAcq_rule: {
      get_and_setNAcqNode *node = new get_and_setNAcqNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setPAcq_rule: {
      get_and_setPAcqNode *node = new get_and_setPAcqNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_addL_rule: {
      get_and_addLNode *node = new get_and_addLNode();
      return node;
    }
  case get_and_addL_no_res_rule: {
      get_and_addL_no_resNode *node = new get_and_addL_no_resNode();
      return node;
    }
  case get_and_addLi_rule: {
      get_and_addLiNode *node = new get_and_addLiNode();
      return node;
    }
  case get_and_addLi_no_res_rule: {
      get_and_addLi_no_resNode *node = new get_and_addLi_no_resNode();
      return node;
    }
  case get_and_addI_rule: {
      get_and_addINode *node = new get_and_addINode();
      return node;
    }
  case get_and_addI_no_res_rule: {
      get_and_addI_no_resNode *node = new get_and_addI_no_resNode();
      return node;
    }
  case get_and_addIi_rule: {
      get_and_addIiNode *node = new get_and_addIiNode();
      return node;
    }
  case get_and_addIi_no_res_rule: {
      get_and_addIi_no_resNode *node = new get_and_addIi_no_resNode();
      return node;
    }
  case get_and_addLAcq_rule: {
      get_and_addLAcqNode *node = new get_and_addLAcqNode();
      return node;
    }
  case get_and_addL_no_resAcq_rule: {
      get_and_addL_no_resAcqNode *node = new get_and_addL_no_resAcqNode();
      return node;
    }
  case get_and_addLiAcq_rule: {
      get_and_addLiAcqNode *node = new get_and_addLiAcqNode();
      return node;
    }
  case get_and_addLi_no_resAcq_rule: {
      get_and_addLi_no_resAcqNode *node = new get_and_addLi_no_resAcqNode();
      return node;
    }
  case get_and_addIAcq_rule: {
      get_and_addIAcqNode *node = new get_and_addIAcqNode();
      return node;
    }
  case get_and_addI_no_resAcq_rule: {
      get_and_addI_no_resAcqNode *node = new get_and_addI_no_resAcqNode();
      return node;
    }
  case get_and_addIiAcq_rule: {
      get_and_addIiAcqNode *node = new get_and_addIiAcqNode();
      return node;
    }
  case get_and_addIi_no_resAcq_rule: {
      get_and_addIi_no_resAcqNode *node = new get_and_addIi_no_resAcqNode();
      return node;
    }
  case cmpL3_reg_reg_rule: {
      cmpL3_reg_regNode *node = new cmpL3_reg_regNode();
      return node;
    }
  case cmpL3_reg_imm_rule: {
      cmpL3_reg_immNode *node = new cmpL3_reg_immNode();
      return node;
    }
  case cmovI_reg_reg_rule: {
      cmovI_reg_regNode *node = new cmovI_reg_regNode();
      return node;
    }
  case cmovUI_reg_reg_rule: {
      cmovUI_reg_regNode *node = new cmovUI_reg_regNode();
      return node;
    }
  case cmovI_zero_reg_rule: {
      cmovI_zero_regNode *node = new cmovI_zero_regNode();
      return node;
    }
  case cmovUI_zero_reg_rule: {
      cmovUI_zero_regNode *node = new cmovUI_zero_regNode();
      return node;
    }
  case cmovI_reg_zero_rule: {
      cmovI_reg_zeroNode *node = new cmovI_reg_zeroNode();
      return node;
    }
  case cmovUI_reg_zero_rule: {
      cmovUI_reg_zeroNode *node = new cmovUI_reg_zeroNode();
      return node;
    }
  case cmovI_reg_zero_one_rule: {
      cmovI_reg_zero_oneNode *node = new cmovI_reg_zero_oneNode();
      return node;
    }
  case cmovUI_reg_zero_one_rule: {
      cmovUI_reg_zero_oneNode *node = new cmovUI_reg_zero_oneNode();
      return node;
    }
  case cmovL_reg_reg_rule: {
      cmovL_reg_regNode *node = new cmovL_reg_regNode();
      return node;
    }
  case cmovUL_reg_reg_rule: {
      cmovUL_reg_regNode *node = new cmovUL_reg_regNode();
      return node;
    }
  case cmovL_reg_zero_rule: {
      cmovL_reg_zeroNode *node = new cmovL_reg_zeroNode();
      return node;
    }
  case cmovUL_reg_zero_rule: {
      cmovUL_reg_zeroNode *node = new cmovUL_reg_zeroNode();
      return node;
    }
  case cmovL_zero_reg_rule: {
      cmovL_zero_regNode *node = new cmovL_zero_regNode();
      return node;
    }
  case cmovUL_zero_reg_rule: {
      cmovUL_zero_regNode *node = new cmovUL_zero_regNode();
      return node;
    }
  case cmovP_reg_reg_rule: {
      cmovP_reg_regNode *node = new cmovP_reg_regNode();
      return node;
    }
  case cmovUP_reg_reg_rule: {
      cmovUP_reg_regNode *node = new cmovUP_reg_regNode();
      return node;
    }
  case cmovP_reg_zero_rule: {
      cmovP_reg_zeroNode *node = new cmovP_reg_zeroNode();
      return node;
    }
  case cmovUP_reg_zero_rule: {
      cmovUP_reg_zeroNode *node = new cmovUP_reg_zeroNode();
      return node;
    }
  case cmovP_zero_reg_rule: {
      cmovP_zero_regNode *node = new cmovP_zero_regNode();
      return node;
    }
  case cmovUP_zero_reg_rule: {
      cmovUP_zero_regNode *node = new cmovUP_zero_regNode();
      return node;
    }
  case cmovN_reg_reg_rule: {
      cmovN_reg_regNode *node = new cmovN_reg_regNode();
      return node;
    }
  case cmovUN_reg_reg_rule: {
      cmovUN_reg_regNode *node = new cmovUN_reg_regNode();
      return node;
    }
  case cmovN_reg_zero_rule: {
      cmovN_reg_zeroNode *node = new cmovN_reg_zeroNode();
      return node;
    }
  case cmovUN_reg_zero_rule: {
      cmovUN_reg_zeroNode *node = new cmovUN_reg_zeroNode();
      return node;
    }
  case cmovN_zero_reg_rule: {
      cmovN_zero_regNode *node = new cmovN_zero_regNode();
      return node;
    }
  case cmovUN_zero_reg_rule: {
      cmovUN_zero_regNode *node = new cmovUN_zero_regNode();
      return node;
    }
  case cmovF_reg_rule: {
      cmovF_regNode *node = new cmovF_regNode();
      return node;
    }
  case cmovUF_reg_rule: {
      cmovUF_regNode *node = new cmovUF_regNode();
      return node;
    }
  case cmovD_reg_rule: {
      cmovD_regNode *node = new cmovD_regNode();
      return node;
    }
  case cmovUD_reg_rule: {
      cmovUD_regNode *node = new cmovUD_regNode();
      return node;
    }
  case addI_reg_reg_rule: {
      addI_reg_regNode *node = new addI_reg_regNode();
      return node;
    }
  case addI_reg_imm_rule: {
      addI_reg_immNode *node = new addI_reg_immNode();
      return node;
    }
  case addI_reg_imm_i2l_rule: {
      addI_reg_imm_i2lNode *node = new addI_reg_imm_i2lNode();
      return node;
    }
  case addP_reg_reg_rule: {
      addP_reg_regNode *node = new addP_reg_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_ext_rule: {
      addP_reg_reg_extNode *node = new addP_reg_reg_extNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_lsl_rule: {
      addP_reg_reg_lslNode *node = new addP_reg_reg_lslNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_ext_shift_rule: {
      addP_reg_reg_ext_shiftNode *node = new addP_reg_reg_ext_shiftNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case lshift_ext_rule: {
      lshift_extNode *node = new lshift_extNode();
      return node;
    }
  case addP_reg_imm_rule: {
      addP_reg_immNode *node = new addP_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addL_reg_reg_rule: {
      addL_reg_regNode *node = new addL_reg_regNode();
      return node;
    }
  case addL_reg_imm_rule: {
      addL_reg_immNode *node = new addL_reg_immNode();
      return node;
    }
  case subI_reg_reg_rule: {
      subI_reg_regNode *node = new subI_reg_regNode();
      return node;
    }
  case subI_reg_imm_rule: {
      subI_reg_immNode *node = new subI_reg_immNode();
      return node;
    }
  case subL_reg_reg_rule: {
      subL_reg_regNode *node = new subL_reg_regNode();
      return node;
    }
  case subL_reg_imm_rule: {
      subL_reg_immNode *node = new subL_reg_immNode();
      return node;
    }
  case negI_reg_rule: {
      negI_regNode *node = new negI_regNode();
      return node;
    }
  case negL_reg_rule: {
      negL_regNode *node = new negL_regNode();
      return node;
    }
  case mulI_rule: {
      mulINode *node = new mulINode();
      return node;
    }
  case smulI_rule: {
      smulINode *node = new smulINode();
      return node;
    }
  case smulI_0_rule: {
      smulI_0Node *node = new smulI_0Node();
      return node;
    }
  case mulL_rule: {
      mulLNode *node = new mulLNode();
      return node;
    }
  case mulHiL_rReg_rule: {
      mulHiL_rRegNode *node = new mulHiL_rRegNode();
      return node;
    }
  case maddI_rule: {
      maddINode *node = new maddINode();
      return node;
    }
  case maddI_0_rule: {
      maddI_0Node *node = new maddI_0Node();
      return node;
    }
  case msubI_rule: {
      msubINode *node = new msubINode();
      return node;
    }
  case maddL_rule: {
      maddLNode *node = new maddLNode();
      return node;
    }
  case maddL_0_rule: {
      maddL_0Node *node = new maddL_0Node();
      return node;
    }
  case msubL_rule: {
      msubLNode *node = new msubLNode();
      return node;
    }
  case smaddL_rule: {
      smaddLNode *node = new smaddLNode();
      return node;
    }
  case smaddL_1_rule: {
      smaddL_1Node *node = new smaddL_1Node();
      return node;
    }
  case smaddL_0_rule: {
      smaddL_0Node *node = new smaddL_0Node();
      return node;
    }
  case smaddL_2_rule: {
      smaddL_2Node *node = new smaddL_2Node();
      return node;
    }
  case smsubL_rule: {
      smsubLNode *node = new smsubLNode();
      return node;
    }
  case smsubL_0_rule: {
      smsubL_0Node *node = new smsubL_0Node();
      return node;
    }
  case smnegL_rule: {
      smnegLNode *node = new smnegLNode();
      return node;
    }
  case smnegL_0_rule: {
      smnegL_0Node *node = new smnegL_0Node();
      return node;
    }
  case smnegL_1_rule: {
      smnegL_1Node *node = new smnegL_1Node();
      return node;
    }
  case smnegL_2_rule: {
      smnegL_2Node *node = new smnegL_2Node();
      return node;
    }
  case divI_rule: {
      divINode *node = new divINode();
      return node;
    }
  case divL_rule: {
      divLNode *node = new divLNode();
      return node;
    }
  case modI_rule: {
      modINode *node = new modINode();
      return node;
    }
  case modL_rule: {
      modLNode *node = new modLNode();
      return node;
    }
  case lShiftI_reg_reg_rule: {
      lShiftI_reg_regNode *node = new lShiftI_reg_regNode();
      return node;
    }
  case lShiftI_reg_imm_rule: {
      lShiftI_reg_immNode *node = new lShiftI_reg_immNode();
      return node;
    }
  case urShiftI_reg_reg_rule: {
      urShiftI_reg_regNode *node = new urShiftI_reg_regNode();
      return node;
    }
  case urShiftI_reg_imm_rule: {
      urShiftI_reg_immNode *node = new urShiftI_reg_immNode();
      return node;
    }
  case rShiftI_reg_reg_rule: {
      rShiftI_reg_regNode *node = new rShiftI_reg_regNode();
      return node;
    }
  case rShiftI_reg_imm_rule: {
      rShiftI_reg_immNode *node = new rShiftI_reg_immNode();
      return node;
    }
  case lShiftL_reg_reg_rule: {
      lShiftL_reg_regNode *node = new lShiftL_reg_regNode();
      return node;
    }
  case lShiftL_reg_imm_rule: {
      lShiftL_reg_immNode *node = new lShiftL_reg_immNode();
      return node;
    }
  case urShiftL_reg_reg_rule: {
      urShiftL_reg_regNode *node = new urShiftL_reg_regNode();
      return node;
    }
  case urShiftL_reg_imm_rule: {
      urShiftL_reg_immNode *node = new urShiftL_reg_immNode();
      return node;
    }
  case urShiftP_reg_imm_rule: {
      urShiftP_reg_immNode *node = new urShiftP_reg_immNode();
      return node;
    }
  case rShiftL_reg_reg_rule: {
      rShiftL_reg_regNode *node = new rShiftL_reg_regNode();
      return node;
    }
  case rShiftL_reg_imm_rule: {
      rShiftL_reg_immNode *node = new rShiftL_reg_immNode();
      return node;
    }
  case regL_not_reg_rule: {
      regL_not_regNode *node = new regL_not_regNode();
      return node;
    }
  case regI_not_reg_rule: {
      regI_not_regNode *node = new regI_not_regNode();
      return node;
    }
  case AndI_reg_not_reg_rule: {
      AndI_reg_not_regNode *node = new AndI_reg_not_regNode();
      return node;
    }
  case AndI_reg_not_reg_0_rule: {
      AndI_reg_not_reg_0Node *node = new AndI_reg_not_reg_0Node();
      return node;
    }
  case AndL_reg_not_reg_rule: {
      AndL_reg_not_regNode *node = new AndL_reg_not_regNode();
      return node;
    }
  case AndL_reg_not_reg_0_rule: {
      AndL_reg_not_reg_0Node *node = new AndL_reg_not_reg_0Node();
      return node;
    }
  case OrI_reg_not_reg_rule: {
      OrI_reg_not_regNode *node = new OrI_reg_not_regNode();
      return node;
    }
  case OrI_reg_not_reg_0_rule: {
      OrI_reg_not_reg_0Node *node = new OrI_reg_not_reg_0Node();
      return node;
    }
  case OrL_reg_not_reg_rule: {
      OrL_reg_not_regNode *node = new OrL_reg_not_regNode();
      return node;
    }
  case OrL_reg_not_reg_0_rule: {
      OrL_reg_not_reg_0Node *node = new OrL_reg_not_reg_0Node();
      return node;
    }
  case XorI_reg_not_reg_rule: {
      XorI_reg_not_regNode *node = new XorI_reg_not_regNode();
      return node;
    }
  case XorI_reg_not_reg_0_rule: {
      XorI_reg_not_reg_0Node *node = new XorI_reg_not_reg_0Node();
      return node;
    }
  case XorL_reg_not_reg_rule: {
      XorL_reg_not_regNode *node = new XorL_reg_not_regNode();
      return node;
    }
  case XorL_reg_not_reg_0_rule: {
      XorL_reg_not_reg_0Node *node = new XorL_reg_not_reg_0Node();
      return node;
    }
  case AndI_reg_URShift_not_reg_rule: {
      AndI_reg_URShift_not_regNode *node = new AndI_reg_URShift_not_regNode();
      return node;
    }
  case AndI_reg_URShift_not_reg_0_rule: {
      AndI_reg_URShift_not_reg_0Node *node = new AndI_reg_URShift_not_reg_0Node();
      return node;
    }
  case AndL_reg_URShift_not_reg_rule: {
      AndL_reg_URShift_not_regNode *node = new AndL_reg_URShift_not_regNode();
      return node;
    }
  case AndL_reg_URShift_not_reg_0_rule: {
      AndL_reg_URShift_not_reg_0Node *node = new AndL_reg_URShift_not_reg_0Node();
      return node;
    }
  case AndI_reg_RShift_not_reg_rule: {
      AndI_reg_RShift_not_regNode *node = new AndI_reg_RShift_not_regNode();
      return node;
    }
  case AndI_reg_RShift_not_reg_0_rule: {
      AndI_reg_RShift_not_reg_0Node *node = new AndI_reg_RShift_not_reg_0Node();
      return node;
    }
  case AndL_reg_RShift_not_reg_rule: {
      AndL_reg_RShift_not_regNode *node = new AndL_reg_RShift_not_regNode();
      return node;
    }
  case AndL_reg_RShift_not_reg_0_rule: {
      AndL_reg_RShift_not_reg_0Node *node = new AndL_reg_RShift_not_reg_0Node();
      return node;
    }
  case AndI_reg_LShift_not_reg_rule: {
      AndI_reg_LShift_not_regNode *node = new AndI_reg_LShift_not_regNode();
      return node;
    }
  case AndI_reg_LShift_not_reg_0_rule: {
      AndI_reg_LShift_not_reg_0Node *node = new AndI_reg_LShift_not_reg_0Node();
      return node;
    }
  case AndL_reg_LShift_not_reg_rule: {
      AndL_reg_LShift_not_regNode *node = new AndL_reg_LShift_not_regNode();
      return node;
    }
  case AndL_reg_LShift_not_reg_0_rule: {
      AndL_reg_LShift_not_reg_0Node *node = new AndL_reg_LShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_URShift_not_reg_rule: {
      XorI_reg_URShift_not_regNode *node = new XorI_reg_URShift_not_regNode();
      return node;
    }
  case XorI_reg_URShift_not_reg_1_rule: {
      XorI_reg_URShift_not_reg_1Node *node = new XorI_reg_URShift_not_reg_1Node();
      return node;
    }
  case XorI_reg_URShift_not_reg_0_rule: {
      XorI_reg_URShift_not_reg_0Node *node = new XorI_reg_URShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_URShift_not_reg_2_rule: {
      XorI_reg_URShift_not_reg_2Node *node = new XorI_reg_URShift_not_reg_2Node();
      return node;
    }
  case XorL_reg_URShift_not_reg_rule: {
      XorL_reg_URShift_not_regNode *node = new XorL_reg_URShift_not_regNode();
      return node;
    }
  case XorL_reg_URShift_not_reg_1_rule: {
      XorL_reg_URShift_not_reg_1Node *node = new XorL_reg_URShift_not_reg_1Node();
      return node;
    }
  case XorL_reg_URShift_not_reg_0_rule: {
      XorL_reg_URShift_not_reg_0Node *node = new XorL_reg_URShift_not_reg_0Node();
      return node;
    }
  case XorL_reg_URShift_not_reg_2_rule: {
      XorL_reg_URShift_not_reg_2Node *node = new XorL_reg_URShift_not_reg_2Node();
      return node;
    }
  case XorI_reg_RShift_not_reg_rule: {
      XorI_reg_RShift_not_regNode *node = new XorI_reg_RShift_not_regNode();
      return node;
    }
  case XorI_reg_RShift_not_reg_1_rule: {
      XorI_reg_RShift_not_reg_1Node *node = new XorI_reg_RShift_not_reg_1Node();
      return node;
    }
  case XorI_reg_RShift_not_reg_0_rule: {
      XorI_reg_RShift_not_reg_0Node *node = new XorI_reg_RShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_RShift_not_reg_2_rule: {
      XorI_reg_RShift_not_reg_2Node *node = new XorI_reg_RShift_not_reg_2Node();
      return node;
    }
  case XorL_reg_RShift_not_reg_rule: {
      XorL_reg_RShift_not_regNode *node = new XorL_reg_RShift_not_regNode();
      return node;
    }
  case XorL_reg_RShift_not_reg_1_rule: {
      XorL_reg_RShift_not_reg_1Node *node = new XorL_reg_RShift_not_reg_1Node();
      return node;
    }
  case XorL_reg_RShift_not_reg_0_rule: {
      XorL_reg_RShift_not_reg_0Node *node = new XorL_reg_RShift_not_reg_0Node();
      return node;
    }
  case XorL_reg_RShift_not_reg_2_rule: {
      XorL_reg_RShift_not_reg_2Node *node = new XorL_reg_RShift_not_reg_2Node();
      return node;
    }
  case XorI_reg_LShift_not_reg_rule: {
      XorI_reg_LShift_not_regNode *node = new XorI_reg_LShift_not_regNode();
      return node;
    }
  case XorI_reg_LShift_not_reg_1_rule: {
      XorI_reg_LShift_not_reg_1Node *node = new XorI_reg_LShift_not_reg_1Node();
      return node;
    }
  case XorI_reg_LShift_not_reg_0_rule: {
      XorI_reg_LShift_not_reg_0Node *node = new XorI_reg_LShift_not_reg_0Node();
      return node;
    }
  case XorI_reg_LShift_not_reg_2_rule: {
      XorI_reg_LShift_not_reg_2Node *node = new XorI_reg_LShift_not_reg_2Node();
      return node;
    }
  case XorL_reg_LShift_not_reg_rule: {
      XorL_reg_LShift_not_regNode *node = new XorL_reg_LShift_not_regNode();
      return node;
    }
  case XorL_reg_LShift_not_reg_1_rule: {
      XorL_reg_LShift_not_reg_1Node *node = new XorL_reg_LShift_not_reg_1Node();
      return node;
    }
  case XorL_reg_LShift_not_reg_0_rule: {
      XorL_reg_LShift_not_reg_0Node *node = new XorL_reg_LShift_not_reg_0Node();
      return node;
    }
  case XorL_reg_LShift_not_reg_2_rule: {
      XorL_reg_LShift_not_reg_2Node *node = new XorL_reg_LShift_not_reg_2Node();
      return node;
    }
  case OrI_reg_URShift_not_reg_rule: {
      OrI_reg_URShift_not_regNode *node = new OrI_reg_URShift_not_regNode();
      return node;
    }
  case OrI_reg_URShift_not_reg_0_rule: {
      OrI_reg_URShift_not_reg_0Node *node = new OrI_reg_URShift_not_reg_0Node();
      return node;
    }
  case OrL_reg_URShift_not_reg_rule: {
      OrL_reg_URShift_not_regNode *node = new OrL_reg_URShift_not_regNode();
      return node;
    }
  case OrL_reg_URShift_not_reg_0_rule: {
      OrL_reg_URShift_not_reg_0Node *node = new OrL_reg_URShift_not_reg_0Node();
      return node;
    }
  case OrI_reg_RShift_not_reg_rule: {
      OrI_reg_RShift_not_regNode *node = new OrI_reg_RShift_not_regNode();
      return node;
    }
  case OrI_reg_RShift_not_reg_0_rule: {
      OrI_reg_RShift_not_reg_0Node *node = new OrI_reg_RShift_not_reg_0Node();
      return node;
    }
  case OrL_reg_RShift_not_reg_rule: {
      OrL_reg_RShift_not_regNode *node = new OrL_reg_RShift_not_regNode();
      return node;
    }
  case OrL_reg_RShift_not_reg_0_rule: {
      OrL_reg_RShift_not_reg_0Node *node = new OrL_reg_RShift_not_reg_0Node();
      return node;
    }
  case OrI_reg_LShift_not_reg_rule: {
      OrI_reg_LShift_not_regNode *node = new OrI_reg_LShift_not_regNode();
      return node;
    }
  case OrI_reg_LShift_not_reg_0_rule: {
      OrI_reg_LShift_not_reg_0Node *node = new OrI_reg_LShift_not_reg_0Node();
      return node;
    }
  case OrL_reg_LShift_not_reg_rule: {
      OrL_reg_LShift_not_regNode *node = new OrL_reg_LShift_not_regNode();
      return node;
    }
  case OrL_reg_LShift_not_reg_0_rule: {
      OrL_reg_LShift_not_reg_0Node *node = new OrL_reg_LShift_not_reg_0Node();
      return node;
    }
  case AndI_reg_URShift_reg_rule: {
      AndI_reg_URShift_regNode *node = new AndI_reg_URShift_regNode();
      return node;
    }
  case AndI_reg_URShift_reg_0_rule: {
      AndI_reg_URShift_reg_0Node *node = new AndI_reg_URShift_reg_0Node();
      return node;
    }
  case AndL_reg_URShift_reg_rule: {
      AndL_reg_URShift_regNode *node = new AndL_reg_URShift_regNode();
      return node;
    }
  case AndL_reg_URShift_reg_0_rule: {
      AndL_reg_URShift_reg_0Node *node = new AndL_reg_URShift_reg_0Node();
      return node;
    }
  case AndI_reg_RShift_reg_rule: {
      AndI_reg_RShift_regNode *node = new AndI_reg_RShift_regNode();
      return node;
    }
  case AndI_reg_RShift_reg_0_rule: {
      AndI_reg_RShift_reg_0Node *node = new AndI_reg_RShift_reg_0Node();
      return node;
    }
  case AndL_reg_RShift_reg_rule: {
      AndL_reg_RShift_regNode *node = new AndL_reg_RShift_regNode();
      return node;
    }
  case AndL_reg_RShift_reg_0_rule: {
      AndL_reg_RShift_reg_0Node *node = new AndL_reg_RShift_reg_0Node();
      return node;
    }
  case AndI_reg_LShift_reg_rule: {
      AndI_reg_LShift_regNode *node = new AndI_reg_LShift_regNode();
      return node;
    }
  case AndI_reg_LShift_reg_0_rule: {
      AndI_reg_LShift_reg_0Node *node = new AndI_reg_LShift_reg_0Node();
      return node;
    }
  case AndL_reg_LShift_reg_rule: {
      AndL_reg_LShift_regNode *node = new AndL_reg_LShift_regNode();
      return node;
    }
  case AndL_reg_LShift_reg_0_rule: {
      AndL_reg_LShift_reg_0Node *node = new AndL_reg_LShift_reg_0Node();
      return node;
    }
  case XorI_reg_URShift_reg_rule: {
      XorI_reg_URShift_regNode *node = new XorI_reg_URShift_regNode();
      return node;
    }
  case XorI_reg_URShift_reg_0_rule: {
      XorI_reg_URShift_reg_0Node *node = new XorI_reg_URShift_reg_0Node();
      return node;
    }
  case XorL_reg_URShift_reg_rule: {
      XorL_reg_URShift_regNode *node = new XorL_reg_URShift_regNode();
      return node;
    }
  case XorL_reg_URShift_reg_0_rule: {
      XorL_reg_URShift_reg_0Node *node = new XorL_reg_URShift_reg_0Node();
      return node;
    }
  case XorI_reg_RShift_reg_rule: {
      XorI_reg_RShift_regNode *node = new XorI_reg_RShift_regNode();
      return node;
    }
  case XorI_reg_RShift_reg_0_rule: {
      XorI_reg_RShift_reg_0Node *node = new XorI_reg_RShift_reg_0Node();
      return node;
    }
  case XorL_reg_RShift_reg_rule: {
      XorL_reg_RShift_regNode *node = new XorL_reg_RShift_regNode();
      return node;
    }
  case XorL_reg_RShift_reg_0_rule: {
      XorL_reg_RShift_reg_0Node *node = new XorL_reg_RShift_reg_0Node();
      return node;
    }
  case XorI_reg_LShift_reg_rule: {
      XorI_reg_LShift_regNode *node = new XorI_reg_LShift_regNode();
      return node;
    }
  case XorI_reg_LShift_reg_0_rule: {
      XorI_reg_LShift_reg_0Node *node = new XorI_reg_LShift_reg_0Node();
      return node;
    }
  case XorL_reg_LShift_reg_rule: {
      XorL_reg_LShift_regNode *node = new XorL_reg_LShift_regNode();
      return node;
    }
  case XorL_reg_LShift_reg_0_rule: {
      XorL_reg_LShift_reg_0Node *node = new XorL_reg_LShift_reg_0Node();
      return node;
    }
  case OrI_reg_URShift_reg_rule: {
      OrI_reg_URShift_regNode *node = new OrI_reg_URShift_regNode();
      return node;
    }
  case OrI_reg_URShift_reg_0_rule: {
      OrI_reg_URShift_reg_0Node *node = new OrI_reg_URShift_reg_0Node();
      return node;
    }
  case OrL_reg_URShift_reg_rule: {
      OrL_reg_URShift_regNode *node = new OrL_reg_URShift_regNode();
      return node;
    }
  case OrL_reg_URShift_reg_0_rule: {
      OrL_reg_URShift_reg_0Node *node = new OrL_reg_URShift_reg_0Node();
      return node;
    }
  case OrI_reg_RShift_reg_rule: {
      OrI_reg_RShift_regNode *node = new OrI_reg_RShift_regNode();
      return node;
    }
  case OrI_reg_RShift_reg_0_rule: {
      OrI_reg_RShift_reg_0Node *node = new OrI_reg_RShift_reg_0Node();
      return node;
    }
  case OrL_reg_RShift_reg_rule: {
      OrL_reg_RShift_regNode *node = new OrL_reg_RShift_regNode();
      return node;
    }
  case OrL_reg_RShift_reg_0_rule: {
      OrL_reg_RShift_reg_0Node *node = new OrL_reg_RShift_reg_0Node();
      return node;
    }
  case OrI_reg_LShift_reg_rule: {
      OrI_reg_LShift_regNode *node = new OrI_reg_LShift_regNode();
      return node;
    }
  case OrI_reg_LShift_reg_0_rule: {
      OrI_reg_LShift_reg_0Node *node = new OrI_reg_LShift_reg_0Node();
      return node;
    }
  case OrL_reg_LShift_reg_rule: {
      OrL_reg_LShift_regNode *node = new OrL_reg_LShift_regNode();
      return node;
    }
  case OrL_reg_LShift_reg_0_rule: {
      OrL_reg_LShift_reg_0Node *node = new OrL_reg_LShift_reg_0Node();
      return node;
    }
  case AddI_reg_URShift_reg_rule: {
      AddI_reg_URShift_regNode *node = new AddI_reg_URShift_regNode();
      return node;
    }
  case AddI_reg_URShift_reg_0_rule: {
      AddI_reg_URShift_reg_0Node *node = new AddI_reg_URShift_reg_0Node();
      return node;
    }
  case AddL_reg_URShift_reg_rule: {
      AddL_reg_URShift_regNode *node = new AddL_reg_URShift_regNode();
      return node;
    }
  case AddL_reg_URShift_reg_0_rule: {
      AddL_reg_URShift_reg_0Node *node = new AddL_reg_URShift_reg_0Node();
      return node;
    }
  case AddI_reg_RShift_reg_rule: {
      AddI_reg_RShift_regNode *node = new AddI_reg_RShift_regNode();
      return node;
    }
  case AddI_reg_RShift_reg_0_rule: {
      AddI_reg_RShift_reg_0Node *node = new AddI_reg_RShift_reg_0Node();
      return node;
    }
  case AddL_reg_RShift_reg_rule: {
      AddL_reg_RShift_regNode *node = new AddL_reg_RShift_regNode();
      return node;
    }
  case AddL_reg_RShift_reg_0_rule: {
      AddL_reg_RShift_reg_0Node *node = new AddL_reg_RShift_reg_0Node();
      return node;
    }
  case AddI_reg_LShift_reg_rule: {
      AddI_reg_LShift_regNode *node = new AddI_reg_LShift_regNode();
      return node;
    }
  case AddI_reg_LShift_reg_0_rule: {
      AddI_reg_LShift_reg_0Node *node = new AddI_reg_LShift_reg_0Node();
      return node;
    }
  case AddL_reg_LShift_reg_rule: {
      AddL_reg_LShift_regNode *node = new AddL_reg_LShift_regNode();
      return node;
    }
  case AddL_reg_LShift_reg_0_rule: {
      AddL_reg_LShift_reg_0Node *node = new AddL_reg_LShift_reg_0Node();
      return node;
    }
  case SubI_reg_URShift_reg_rule: {
      SubI_reg_URShift_regNode *node = new SubI_reg_URShift_regNode();
      return node;
    }
  case SubL_reg_URShift_reg_rule: {
      SubL_reg_URShift_regNode *node = new SubL_reg_URShift_regNode();
      return node;
    }
  case SubI_reg_RShift_reg_rule: {
      SubI_reg_RShift_regNode *node = new SubI_reg_RShift_regNode();
      return node;
    }
  case SubL_reg_RShift_reg_rule: {
      SubL_reg_RShift_regNode *node = new SubL_reg_RShift_regNode();
      return node;
    }
  case SubI_reg_LShift_reg_rule: {
      SubI_reg_LShift_regNode *node = new SubI_reg_LShift_regNode();
      return node;
    }
  case SubL_reg_LShift_reg_rule: {
      SubL_reg_LShift_regNode *node = new SubL_reg_LShift_regNode();
      return node;
    }
  case sbfmL_rule: {
      sbfmLNode *node = new sbfmLNode();
      return node;
    }
  case sbfmwI_rule: {
      sbfmwINode *node = new sbfmwINode();
      return node;
    }
  case ubfmL_rule: {
      ubfmLNode *node = new ubfmLNode();
      return node;
    }
  case ubfmwI_rule: {
      ubfmwINode *node = new ubfmwINode();
      return node;
    }
  case ubfxwI_rule: {
      ubfxwINode *node = new ubfxwINode();
      return node;
    }
  case ubfxL_rule: {
      ubfxLNode *node = new ubfxLNode();
      return node;
    }
  case ubfxIConvI2L_rule: {
      ubfxIConvI2LNode *node = new ubfxIConvI2LNode();
      return node;
    }
  case ubfizwI_rule: {
      ubfizwINode *node = new ubfizwINode();
      return node;
    }
  case ubfizL_rule: {
      ubfizLNode *node = new ubfizLNode();
      return node;
    }
  case ubfizwIConvI2L_rule: {
      ubfizwIConvI2LNode *node = new ubfizwIConvI2LNode();
      return node;
    }
  case ubfizLConvL2I_rule: {
      ubfizLConvL2INode *node = new ubfizLConvL2INode();
      return node;
    }
  case ubfizIConvI2L_rule: {
      ubfizIConvI2LNode *node = new ubfizIConvI2LNode();
      return node;
    }
  case ubfizLConvL2Ix_rule: {
      ubfizLConvL2IxNode *node = new ubfizLConvL2IxNode();
      return node;
    }
  case ubfizIConvI2LAndI_rule: {
      ubfizIConvI2LAndINode *node = new ubfizIConvI2LAndINode();
      return node;
    }
  case extrOrL_rule: {
      extrOrLNode *node = new extrOrLNode();
      return node;
    }
  case extrOrL_0_rule: {
      extrOrL_0Node *node = new extrOrL_0Node();
      return node;
    }
  case extrOrI_rule: {
      extrOrINode *node = new extrOrINode();
      return node;
    }
  case extrOrI_0_rule: {
      extrOrI_0Node *node = new extrOrI_0Node();
      return node;
    }
  case extrAddL_rule: {
      extrAddLNode *node = new extrAddLNode();
      return node;
    }
  case extrAddL_0_rule: {
      extrAddL_0Node *node = new extrAddL_0Node();
      return node;
    }
  case extrAddI_rule: {
      extrAddINode *node = new extrAddINode();
      return node;
    }
  case extrAddI_0_rule: {
      extrAddI_0Node *node = new extrAddI_0Node();
      return node;
    }
  case rolL_rReg_Var_C_64_rule: {
      rolL_rReg_Var_C_64Node *node = new rolL_rReg_Var_C_64Node();
      return node;
    }
  case rolL_rReg_Var_C_64_0_rule: {
      rolL_rReg_Var_C_64_0Node *node = new rolL_rReg_Var_C_64_0Node();
      return node;
    }
  case rolL_rReg_Var_C0_rule: {
      rolL_rReg_Var_C0Node *node = new rolL_rReg_Var_C0Node();
      return node;
    }
  case rolL_rReg_Var_C0_0_rule: {
      rolL_rReg_Var_C0_0Node *node = new rolL_rReg_Var_C0_0Node();
      return node;
    }
  case rolI_rReg_Var_C_32_rule: {
      rolI_rReg_Var_C_32Node *node = new rolI_rReg_Var_C_32Node();
      return node;
    }
  case rolI_rReg_Var_C_32_0_rule: {
      rolI_rReg_Var_C_32_0Node *node = new rolI_rReg_Var_C_32_0Node();
      return node;
    }
  case rolI_rReg_Var_C0_rule: {
      rolI_rReg_Var_C0Node *node = new rolI_rReg_Var_C0Node();
      return node;
    }
  case rolI_rReg_Var_C0_0_rule: {
      rolI_rReg_Var_C0_0Node *node = new rolI_rReg_Var_C0_0Node();
      return node;
    }
  case rorL_rReg_Var_C_64_rule: {
      rorL_rReg_Var_C_64Node *node = new rorL_rReg_Var_C_64Node();
      return node;
    }
  case rorL_rReg_Var_C_64_0_rule: {
      rorL_rReg_Var_C_64_0Node *node = new rorL_rReg_Var_C_64_0Node();
      return node;
    }
  case rorL_rReg_Var_C0_rule: {
      rorL_rReg_Var_C0Node *node = new rorL_rReg_Var_C0Node();
      return node;
    }
  case rorL_rReg_Var_C0_0_rule: {
      rorL_rReg_Var_C0_0Node *node = new rorL_rReg_Var_C0_0Node();
      return node;
    }
  case rorI_rReg_Var_C_32_rule: {
      rorI_rReg_Var_C_32Node *node = new rorI_rReg_Var_C_32Node();
      return node;
    }
  case rorI_rReg_Var_C_32_0_rule: {
      rorI_rReg_Var_C_32_0Node *node = new rorI_rReg_Var_C_32_0Node();
      return node;
    }
  case rorI_rReg_Var_C0_rule: {
      rorI_rReg_Var_C0Node *node = new rorI_rReg_Var_C0Node();
      return node;
    }
  case rorI_rReg_Var_C0_0_rule: {
      rorI_rReg_Var_C0_0Node *node = new rorI_rReg_Var_C0_0Node();
      return node;
    }
  case AddExtI_rule: {
      AddExtINode *node = new AddExtINode();
      return node;
    }
  case AddExtI_0_rule: {
      AddExtI_0Node *node = new AddExtI_0Node();
      return node;
    }
  case SubExtI_rule: {
      SubExtINode *node = new SubExtINode();
      return node;
    }
  case AddExtI_sxth_rule: {
      AddExtI_sxthNode *node = new AddExtI_sxthNode();
      return node;
    }
  case AddExtI_sxth_0_rule: {
      AddExtI_sxth_0Node *node = new AddExtI_sxth_0Node();
      return node;
    }
  case AddExtI_sxtb_rule: {
      AddExtI_sxtbNode *node = new AddExtI_sxtbNode();
      return node;
    }
  case AddExtI_sxtb_0_rule: {
      AddExtI_sxtb_0Node *node = new AddExtI_sxtb_0Node();
      return node;
    }
  case AddExtI_uxtb_rule: {
      AddExtI_uxtbNode *node = new AddExtI_uxtbNode();
      return node;
    }
  case AddExtI_uxtb_0_rule: {
      AddExtI_uxtb_0Node *node = new AddExtI_uxtb_0Node();
      return node;
    }
  case AddExtL_sxth_rule: {
      AddExtL_sxthNode *node = new AddExtL_sxthNode();
      return node;
    }
  case AddExtL_sxth_0_rule: {
      AddExtL_sxth_0Node *node = new AddExtL_sxth_0Node();
      return node;
    }
  case AddExtL_sxtw_rule: {
      AddExtL_sxtwNode *node = new AddExtL_sxtwNode();
      return node;
    }
  case AddExtL_sxtw_0_rule: {
      AddExtL_sxtw_0Node *node = new AddExtL_sxtw_0Node();
      return node;
    }
  case AddExtL_sxtb_rule: {
      AddExtL_sxtbNode *node = new AddExtL_sxtbNode();
      return node;
    }
  case AddExtL_sxtb_0_rule: {
      AddExtL_sxtb_0Node *node = new AddExtL_sxtb_0Node();
      return node;
    }
  case AddExtL_uxtb_rule: {
      AddExtL_uxtbNode *node = new AddExtL_uxtbNode();
      return node;
    }
  case AddExtL_uxtb_0_rule: {
      AddExtL_uxtb_0Node *node = new AddExtL_uxtb_0Node();
      return node;
    }
  case AddExtI_uxtb_and_rule: {
      AddExtI_uxtb_andNode *node = new AddExtI_uxtb_andNode();
      return node;
    }
  case AddExtI_uxtb_and_0_rule: {
      AddExtI_uxtb_and_0Node *node = new AddExtI_uxtb_and_0Node();
      return node;
    }
  case AddExtI_uxth_and_rule: {
      AddExtI_uxth_andNode *node = new AddExtI_uxth_andNode();
      return node;
    }
  case AddExtI_uxth_and_0_rule: {
      AddExtI_uxth_and_0Node *node = new AddExtI_uxth_and_0Node();
      return node;
    }
  case AddExtL_uxtb_and_rule: {
      AddExtL_uxtb_andNode *node = new AddExtL_uxtb_andNode();
      return node;
    }
  case AddExtL_uxtb_and_0_rule: {
      AddExtL_uxtb_and_0Node *node = new AddExtL_uxtb_and_0Node();
      return node;
    }
  case AddExtL_uxth_and_rule: {
      AddExtL_uxth_andNode *node = new AddExtL_uxth_andNode();
      return node;
    }
  case AddExtL_uxth_and_0_rule: {
      AddExtL_uxth_and_0Node *node = new AddExtL_uxth_and_0Node();
      return node;
    }
  case AddExtL_uxtw_and_rule: {
      AddExtL_uxtw_andNode *node = new AddExtL_uxtw_andNode();
      return node;
    }
  case AddExtL_uxtw_and_0_rule: {
      AddExtL_uxtw_and_0Node *node = new AddExtL_uxtw_and_0Node();
      return node;
    }
  case SubExtI_uxtb_and_rule: {
      SubExtI_uxtb_andNode *node = new SubExtI_uxtb_andNode();
      return node;
    }
  case SubExtI_uxth_and_rule: {
      SubExtI_uxth_andNode *node = new SubExtI_uxth_andNode();
      return node;
    }
  case SubExtL_uxtb_and_rule: {
      SubExtL_uxtb_andNode *node = new SubExtL_uxtb_andNode();
      return node;
    }
  case SubExtL_uxth_and_rule: {
      SubExtL_uxth_andNode *node = new SubExtL_uxth_andNode();
      return node;
    }
  case SubExtL_uxtw_and_rule: {
      SubExtL_uxtw_andNode *node = new SubExtL_uxtw_andNode();
      return node;
    }
  case AddExtL_sxtb_shift_rule: {
      AddExtL_sxtb_shiftNode *node = new AddExtL_sxtb_shiftNode();
      return node;
    }
  case AddExtL_sxtb_shift_0_rule: {
      AddExtL_sxtb_shift_0Node *node = new AddExtL_sxtb_shift_0Node();
      return node;
    }
  case AddExtL_sxth_shift_rule: {
      AddExtL_sxth_shiftNode *node = new AddExtL_sxth_shiftNode();
      return node;
    }
  case AddExtL_sxth_shift_0_rule: {
      AddExtL_sxth_shift_0Node *node = new AddExtL_sxth_shift_0Node();
      return node;
    }
  case AddExtL_sxtw_shift_rule: {
      AddExtL_sxtw_shiftNode *node = new AddExtL_sxtw_shiftNode();
      return node;
    }
  case AddExtL_sxtw_shift_0_rule: {
      AddExtL_sxtw_shift_0Node *node = new AddExtL_sxtw_shift_0Node();
      return node;
    }
  case SubExtL_sxtb_shift_rule: {
      SubExtL_sxtb_shiftNode *node = new SubExtL_sxtb_shiftNode();
      return node;
    }
  case SubExtL_sxth_shift_rule: {
      SubExtL_sxth_shiftNode *node = new SubExtL_sxth_shiftNode();
      return node;
    }
  case SubExtL_sxtw_shift_rule: {
      SubExtL_sxtw_shiftNode *node = new SubExtL_sxtw_shiftNode();
      return node;
    }
  case AddExtI_sxtb_shift_rule: {
      AddExtI_sxtb_shiftNode *node = new AddExtI_sxtb_shiftNode();
      return node;
    }
  case AddExtI_sxtb_shift_0_rule: {
      AddExtI_sxtb_shift_0Node *node = new AddExtI_sxtb_shift_0Node();
      return node;
    }
  case AddExtI_sxth_shift_rule: {
      AddExtI_sxth_shiftNode *node = new AddExtI_sxth_shiftNode();
      return node;
    }
  case AddExtI_sxth_shift_0_rule: {
      AddExtI_sxth_shift_0Node *node = new AddExtI_sxth_shift_0Node();
      return node;
    }
  case SubExtI_sxtb_shift_rule: {
      SubExtI_sxtb_shiftNode *node = new SubExtI_sxtb_shiftNode();
      return node;
    }
  case SubExtI_sxth_shift_rule: {
      SubExtI_sxth_shiftNode *node = new SubExtI_sxth_shiftNode();
      return node;
    }
  case AddExtI_shift_rule: {
      AddExtI_shiftNode *node = new AddExtI_shiftNode();
      return node;
    }
  case AddExtI_shift_0_rule: {
      AddExtI_shift_0Node *node = new AddExtI_shift_0Node();
      return node;
    }
  case SubExtI_shift_rule: {
      SubExtI_shiftNode *node = new SubExtI_shiftNode();
      return node;
    }
  case AddExtL_uxtb_and_shift_rule: {
      AddExtL_uxtb_and_shiftNode *node = new AddExtL_uxtb_and_shiftNode();
      return node;
    }
  case AddExtL_uxtb_and_shift_0_rule: {
      AddExtL_uxtb_and_shift_0Node *node = new AddExtL_uxtb_and_shift_0Node();
      return node;
    }
  case AddExtL_uxth_and_shift_rule: {
      AddExtL_uxth_and_shiftNode *node = new AddExtL_uxth_and_shiftNode();
      return node;
    }
  case AddExtL_uxth_and_shift_0_rule: {
      AddExtL_uxth_and_shift_0Node *node = new AddExtL_uxth_and_shift_0Node();
      return node;
    }
  case AddExtL_uxtw_and_shift_rule: {
      AddExtL_uxtw_and_shiftNode *node = new AddExtL_uxtw_and_shiftNode();
      return node;
    }
  case AddExtL_uxtw_and_shift_0_rule: {
      AddExtL_uxtw_and_shift_0Node *node = new AddExtL_uxtw_and_shift_0Node();
      return node;
    }
  case SubExtL_uxtb_and_shift_rule: {
      SubExtL_uxtb_and_shiftNode *node = new SubExtL_uxtb_and_shiftNode();
      return node;
    }
  case SubExtL_uxth_and_shift_rule: {
      SubExtL_uxth_and_shiftNode *node = new SubExtL_uxth_and_shiftNode();
      return node;
    }
  case SubExtL_uxtw_and_shift_rule: {
      SubExtL_uxtw_and_shiftNode *node = new SubExtL_uxtw_and_shiftNode();
      return node;
    }
  case AddExtI_uxtb_and_shift_rule: {
      AddExtI_uxtb_and_shiftNode *node = new AddExtI_uxtb_and_shiftNode();
      return node;
    }
  case AddExtI_uxtb_and_shift_0_rule: {
      AddExtI_uxtb_and_shift_0Node *node = new AddExtI_uxtb_and_shift_0Node();
      return node;
    }
  case AddExtI_uxth_and_shift_rule: {
      AddExtI_uxth_and_shiftNode *node = new AddExtI_uxth_and_shiftNode();
      return node;
    }
  case AddExtI_uxth_and_shift_0_rule: {
      AddExtI_uxth_and_shift_0Node *node = new AddExtI_uxth_and_shift_0Node();
      return node;
    }
  case SubExtI_uxtb_and_shift_rule: {
      SubExtI_uxtb_and_shiftNode *node = new SubExtI_uxtb_and_shiftNode();
      return node;
    }
  case SubExtI_uxth_and_shift_rule: {
      SubExtI_uxth_and_shiftNode *node = new SubExtI_uxth_and_shiftNode();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new addF_reg_regNode();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new addD_reg_regNode();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new subF_reg_regNode();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new subD_reg_regNode();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new mulF_reg_regNode();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new mulD_reg_regNode();
      return node;
    }
  case maddF_reg_reg_rule: {
      maddF_reg_regNode *node = new maddF_reg_regNode();
      return node;
    }
  case maddD_reg_reg_rule: {
      maddD_reg_regNode *node = new maddD_reg_regNode();
      return node;
    }
  case msubF_reg_reg_rule: {
      msubF_reg_regNode *node = new msubF_reg_regNode();
      return node;
    }
  case msubF_reg_reg_0_rule: {
      msubF_reg_reg_0Node *node = new msubF_reg_reg_0Node();
      return node;
    }
  case msubD_reg_reg_rule: {
      msubD_reg_regNode *node = new msubD_reg_regNode();
      return node;
    }
  case msubD_reg_reg_0_rule: {
      msubD_reg_reg_0Node *node = new msubD_reg_reg_0Node();
      return node;
    }
  case mnaddF_reg_reg_rule: {
      mnaddF_reg_regNode *node = new mnaddF_reg_regNode();
      return node;
    }
  case mnaddF_reg_reg_0_rule: {
      mnaddF_reg_reg_0Node *node = new mnaddF_reg_reg_0Node();
      return node;
    }
  case mnaddD_reg_reg_rule: {
      mnaddD_reg_regNode *node = new mnaddD_reg_regNode();
      return node;
    }
  case mnaddD_reg_reg_0_rule: {
      mnaddD_reg_reg_0Node *node = new mnaddD_reg_reg_0Node();
      return node;
    }
  case mnsubF_reg_reg_rule: {
      mnsubF_reg_regNode *node = new mnsubF_reg_regNode();
      return node;
    }
  case mnsubD_reg_reg_rule: {
      mnsubD_reg_regNode *node = new mnsubD_reg_regNode();
      return node;
    }
  case maxF_reg_reg_rule: {
      maxF_reg_regNode *node = new maxF_reg_regNode();
      return node;
    }
  case minF_reg_reg_rule: {
      minF_reg_regNode *node = new minF_reg_regNode();
      return node;
    }
  case maxD_reg_reg_rule: {
      maxD_reg_regNode *node = new maxD_reg_regNode();
      return node;
    }
  case minD_reg_reg_rule: {
      minD_reg_regNode *node = new minD_reg_regNode();
      return node;
    }
  case divF_reg_reg_rule: {
      divF_reg_regNode *node = new divF_reg_regNode();
      return node;
    }
  case divD_reg_reg_rule: {
      divD_reg_regNode *node = new divD_reg_regNode();
      return node;
    }
  case negF_reg_reg_rule: {
      negF_reg_regNode *node = new negF_reg_regNode();
      return node;
    }
  case negD_reg_reg_rule: {
      negD_reg_regNode *node = new negD_reg_regNode();
      return node;
    }
  case absI_reg_rule: {
      absI_regNode *node = new absI_regNode();
      return node;
    }
  case absL_reg_rule: {
      absL_regNode *node = new absL_regNode();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new absF_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new absD_regNode();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new sqrtD_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new sqrtF_regNode();
      return node;
    }
  case copySignD_reg_rule: {
      copySignD_regNode *node = new copySignD_regNode();
      node->set_opnd_array(4, MachOperGenerator(VREGD));
      return node;
    }
  case copySignF_reg_rule: {
      copySignF_regNode *node = new copySignF_regNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      return node;
    }
  case signumD_reg_rule: {
      signumD_regNode *node = new signumD_regNode();
      node->set_opnd_array(4, MachOperGenerator(VREGD));
      return node;
    }
  case signumF_reg_rule: {
      signumF_regNode *node = new signumF_regNode();
      node->set_opnd_array(4, MachOperGenerator(VREGF));
      return node;
    }
  case andI_reg_reg_rule: {
      andI_reg_regNode *node = new andI_reg_regNode();
      return node;
    }
  case andI_reg_imm_rule: {
      andI_reg_immNode *node = new andI_reg_immNode();
      return node;
    }
  case orI_reg_reg_rule: {
      orI_reg_regNode *node = new orI_reg_regNode();
      return node;
    }
  case orI_reg_imm_rule: {
      orI_reg_immNode *node = new orI_reg_immNode();
      return node;
    }
  case xorI_reg_reg_rule: {
      xorI_reg_regNode *node = new xorI_reg_regNode();
      return node;
    }
  case xorI_reg_imm_rule: {
      xorI_reg_immNode *node = new xorI_reg_immNode();
      return node;
    }
  case andL_reg_reg_rule: {
      andL_reg_regNode *node = new andL_reg_regNode();
      return node;
    }
  case andL_reg_imm_rule: {
      andL_reg_immNode *node = new andL_reg_immNode();
      return node;
    }
  case orL_reg_reg_rule: {
      orL_reg_regNode *node = new orL_reg_regNode();
      return node;
    }
  case orL_reg_imm_rule: {
      orL_reg_immNode *node = new orL_reg_immNode();
      return node;
    }
  case xorL_reg_reg_rule: {
      xorL_reg_regNode *node = new xorL_reg_regNode();
      return node;
    }
  case xorL_reg_imm_rule: {
      xorL_reg_immNode *node = new xorL_reg_immNode();
      return node;
    }
  case convI2L_reg_reg_rule: {
      convI2L_reg_regNode *node = new convI2L_reg_regNode();
      return node;
    }
  case convUI2L_reg_reg_rule: {
      convUI2L_reg_regNode *node = new convUI2L_reg_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new convL2I_regNode();
      return node;
    }
  case convI2B_rule: {
      convI2BNode *node = new convI2BNode();
      return node;
    }
  case convP2B_rule: {
      convP2BNode *node = new convP2BNode();
      return node;
    }
  case convD2F_reg_rule: {
      convD2F_regNode *node = new convD2F_regNode();
      return node;
    }
  case convF2D_reg_rule: {
      convF2D_regNode *node = new convF2D_regNode();
      return node;
    }
  case convF2I_reg_reg_rule: {
      convF2I_reg_regNode *node = new convF2I_reg_regNode();
      return node;
    }
  case convF2L_reg_reg_rule: {
      convF2L_reg_regNode *node = new convF2L_reg_regNode();
      return node;
    }
  case convI2F_reg_reg_rule: {
      convI2F_reg_regNode *node = new convI2F_reg_regNode();
      return node;
    }
  case convL2F_reg_reg_rule: {
      convL2F_reg_regNode *node = new convL2F_reg_regNode();
      return node;
    }
  case convD2I_reg_reg_rule: {
      convD2I_reg_regNode *node = new convD2I_reg_regNode();
      return node;
    }
  case convD2L_reg_reg_rule: {
      convD2L_reg_regNode *node = new convD2L_reg_regNode();
      return node;
    }
  case convI2D_reg_reg_rule: {
      convI2D_reg_regNode *node = new convI2D_reg_regNode();
      return node;
    }
  case convL2D_reg_reg_rule: {
      convL2D_reg_regNode *node = new convL2D_reg_regNode();
      return node;
    }
  case MoveF2I_stack_reg_rule: {
      MoveF2I_stack_regNode *node = new MoveF2I_stack_regNode();
      return node;
    }
  case MoveI2F_stack_reg_rule: {
      MoveI2F_stack_regNode *node = new MoveI2F_stack_regNode();
      return node;
    }
  case MoveD2L_stack_reg_rule: {
      MoveD2L_stack_regNode *node = new MoveD2L_stack_regNode();
      return node;
    }
  case MoveL2D_stack_reg_rule: {
      MoveL2D_stack_regNode *node = new MoveL2D_stack_regNode();
      return node;
    }
  case MoveF2I_reg_stack_rule: {
      MoveF2I_reg_stackNode *node = new MoveF2I_reg_stackNode();
      return node;
    }
  case MoveI2F_reg_stack_rule: {
      MoveI2F_reg_stackNode *node = new MoveI2F_reg_stackNode();
      return node;
    }
  case MoveD2L_reg_stack_rule: {
      MoveD2L_reg_stackNode *node = new MoveD2L_reg_stackNode();
      return node;
    }
  case MoveL2D_reg_stack_rule: {
      MoveL2D_reg_stackNode *node = new MoveL2D_reg_stackNode();
      return node;
    }
  case MoveF2I_reg_reg_rule: {
      MoveF2I_reg_regNode *node = new MoveF2I_reg_regNode();
      return node;
    }
  case MoveI2F_reg_reg_rule: {
      MoveI2F_reg_regNode *node = new MoveI2F_reg_regNode();
      return node;
    }
  case MoveD2L_reg_reg_rule: {
      MoveD2L_reg_regNode *node = new MoveD2L_reg_regNode();
      return node;
    }
  case MoveL2D_reg_reg_rule: {
      MoveL2D_reg_regNode *node = new MoveL2D_reg_regNode();
      return node;
    }
  case clearArray_reg_reg_rule: {
      clearArray_reg_regNode *node = new clearArray_reg_regNode();
      return node;
    }
  case clearArray_imm_reg_rule: {
      clearArray_imm_regNode *node = new clearArray_imm_regNode();
      return node;
    }
  case overflowAddI_reg_reg_rule: {
      overflowAddI_reg_regNode *node = new overflowAddI_reg_regNode();
      return node;
    }
  case overflowAddI_reg_imm_rule: {
      overflowAddI_reg_immNode *node = new overflowAddI_reg_immNode();
      return node;
    }
  case overflowAddL_reg_reg_rule: {
      overflowAddL_reg_regNode *node = new overflowAddL_reg_regNode();
      return node;
    }
  case overflowAddL_reg_imm_rule: {
      overflowAddL_reg_immNode *node = new overflowAddL_reg_immNode();
      return node;
    }
  case overflowSubI_reg_reg_rule: {
      overflowSubI_reg_regNode *node = new overflowSubI_reg_regNode();
      return node;
    }
  case overflowSubI_reg_imm_rule: {
      overflowSubI_reg_immNode *node = new overflowSubI_reg_immNode();
      return node;
    }
  case overflowSubL_reg_reg_rule: {
      overflowSubL_reg_regNode *node = new overflowSubL_reg_regNode();
      return node;
    }
  case overflowSubL_reg_imm_rule: {
      overflowSubL_reg_immNode *node = new overflowSubL_reg_immNode();
      return node;
    }
  case overflowNegI_reg_rule: {
      overflowNegI_regNode *node = new overflowNegI_regNode();
      return node;
    }
  case overflowNegL_reg_rule: {
      overflowNegL_regNode *node = new overflowNegL_regNode();
      return node;
    }
  case overflowMulI_reg_rule: {
      overflowMulI_regNode *node = new overflowMulI_regNode();
      return node;
    }
  case overflowMulI_reg_branch_rule: {
      overflowMulI_reg_branchNode *node = new overflowMulI_reg_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case overflowMulL_reg_rule: {
      overflowMulL_regNode *node = new overflowMulL_regNode();
      return node;
    }
  case overflowMulL_reg_branch_rule: {
      overflowMulL_reg_branchNode *node = new overflowMulL_reg_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case compI_reg_reg_rule: {
      compI_reg_regNode *node = new compI_reg_regNode();
      return node;
    }
  case compI_reg_immI0_rule: {
      compI_reg_immI0Node *node = new compI_reg_immI0Node();
      return node;
    }
  case compI_reg_immIAddSub_rule: {
      compI_reg_immIAddSubNode *node = new compI_reg_immIAddSubNode();
      return node;
    }
  case compI_reg_immI_rule: {
      compI_reg_immINode *node = new compI_reg_immINode();
      return node;
    }
  case compU_reg_reg_rule: {
      compU_reg_regNode *node = new compU_reg_regNode();
      return node;
    }
  case compU_reg_immI0_rule: {
      compU_reg_immI0Node *node = new compU_reg_immI0Node();
      return node;
    }
  case compU_reg_immIAddSub_rule: {
      compU_reg_immIAddSubNode *node = new compU_reg_immIAddSubNode();
      return node;
    }
  case compU_reg_immI_rule: {
      compU_reg_immINode *node = new compU_reg_immINode();
      return node;
    }
  case compL_reg_reg_rule: {
      compL_reg_regNode *node = new compL_reg_regNode();
      return node;
    }
  case compL_reg_immL0_rule: {
      compL_reg_immL0Node *node = new compL_reg_immL0Node();
      return node;
    }
  case compL_reg_immLAddSub_rule: {
      compL_reg_immLAddSubNode *node = new compL_reg_immLAddSubNode();
      return node;
    }
  case compL_reg_immL_rule: {
      compL_reg_immLNode *node = new compL_reg_immLNode();
      return node;
    }
  case compUL_reg_reg_rule: {
      compUL_reg_regNode *node = new compUL_reg_regNode();
      return node;
    }
  case compUL_reg_immL0_rule: {
      compUL_reg_immL0Node *node = new compUL_reg_immL0Node();
      return node;
    }
  case compUL_reg_immLAddSub_rule: {
      compUL_reg_immLAddSubNode *node = new compUL_reg_immLAddSubNode();
      return node;
    }
  case compUL_reg_immL_rule: {
      compUL_reg_immLNode *node = new compUL_reg_immLNode();
      return node;
    }
  case compP_reg_reg_rule: {
      compP_reg_regNode *node = new compP_reg_regNode();
      return node;
    }
  case compN_reg_reg_rule: {
      compN_reg_regNode *node = new compN_reg_regNode();
      return node;
    }
  case testP_reg_rule: {
      testP_regNode *node = new testP_regNode();
      return node;
    }
  case testN_reg_rule: {
      testN_regNode *node = new testN_regNode();
      return node;
    }
  case compF_reg_reg_rule: {
      compF_reg_regNode *node = new compF_reg_regNode();
      return node;
    }
  case compF_reg_zero_rule: {
      compF_reg_zeroNode *node = new compF_reg_zeroNode();
      return node;
    }
  case compD_reg_reg_rule: {
      compD_reg_regNode *node = new compD_reg_regNode();
      return node;
    }
  case compD_reg_zero_rule: {
      compD_reg_zeroNode *node = new compD_reg_zeroNode();
      return node;
    }
  case compF3_reg_reg_rule: {
      compF3_reg_regNode *node = new compF3_reg_regNode();
      return node;
    }
  case compD3_reg_reg_rule: {
      compD3_reg_regNode *node = new compD3_reg_regNode();
      return node;
    }
  case compF3_reg_immF0_rule: {
      compF3_reg_immF0Node *node = new compF3_reg_immF0Node();
      return node;
    }
  case compD3_reg_immD0_rule: {
      compD3_reg_immD0Node *node = new compD3_reg_immD0Node();
      return node;
    }
  case cmpLTMask_reg_reg_rule: {
      cmpLTMask_reg_regNode *node = new cmpLTMask_reg_regNode();
      return node;
    }
  case cmpLTMask_reg_zero_rule: {
      cmpLTMask_reg_zeroNode *node = new cmpLTMask_reg_zeroNode();
      return node;
    }
  case minI_rReg_rule: {
      minI_rRegNode *node = new minI_rRegNode();
      return node;
    }
  case maxI_rReg_rule: {
      maxI_rRegNode *node = new maxI_rRegNode();
      return node;
    }
  case branch_rule: {
      branchNode *node = new branchNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL));
      return node;
    }
  case branchCon_rule: {
      branchConNode *node = new branchConNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConU_rule: {
      branchConUNode *node = new branchConUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_imm0_branch_rule: {
      cmpI_imm0_branchNode *node = new cmpI_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_imm0_branch_rule: {
      cmpL_imm0_branchNode *node = new cmpL_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_imm0_branch_rule: {
      cmpP_imm0_branchNode *node = new cmpP_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_imm0_branch_rule: {
      cmpN_imm0_branchNode *node = new cmpN_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_narrowOop_imm0_branch_rule: {
      cmpP_narrowOop_imm0_branchNode *node = new cmpP_narrowOop_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUI_imm0_branch_rule: {
      cmpUI_imm0_branchNode *node = new cmpUI_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_imm0_branch_rule: {
      cmpUL_imm0_branchNode *node = new cmpUL_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_branch_sign_rule: {
      cmpL_branch_signNode *node = new cmpL_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_branch_sign_rule: {
      cmpI_branch_signNode *node = new cmpI_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_branch_bit_rule: {
      cmpL_branch_bitNode *node = new cmpL_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_branch_bit_rule: {
      cmpI_branch_bitNode *node = new cmpI_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpL_branch_sign_rule: {
      far_cmpL_branch_signNode *node = new far_cmpL_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_branch_sign_rule: {
      far_cmpI_branch_signNode *node = new far_cmpI_branch_signNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpL_branch_bit_rule: {
      far_cmpL_branch_bitNode *node = new far_cmpL_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_branch_bit_rule: {
      far_cmpI_branch_bitNode *node = new far_cmpI_branch_bitNode();
      node->set_opnd_array(5, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_and_rule: {
      cmpL_andNode *node = new cmpL_andNode();
      return node;
    }
  case cmpI_and_rule: {
      cmpI_andNode *node = new cmpI_andNode();
      return node;
    }
  case cmpL_and_reg_rule: {
      cmpL_and_regNode *node = new cmpL_and_regNode();
      return node;
    }
  case cmpI_and_reg_rule: {
      cmpI_and_regNode *node = new cmpI_and_regNode();
      return node;
    }
  case branchLoopEnd_rule: {
      branchLoopEndNode *node = new branchLoopEndNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchLoopEndU_rule: {
      branchLoopEndUNode *node = new branchLoopEndUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP));
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP));
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case safePoint_rule: {
      safePointNode *node = new safePointNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallLeafNoFPDirect_rule: {
      CallLeafNoFPDirectNode *node = new CallLeafNoFPDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new TailCalljmpIndNode();
      return node;
    }
  case TailjmpInd_rule: {
      TailjmpIndNode *node = new TailjmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new RethrowExceptionNode();
      return node;
    }
  case Ret_rule: {
      RetNode *node = new RetNode();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new ShouldNotReachHereNode();
      node->_halt_reason = _leaf->as_Halt()->_halt_reason;
      node->_reachable   = _leaf->as_Halt()->_reachable;
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new partialSubtypeCheckNode();
      return node;
    }
  case partialSubtypeCheckVsZero_rule: {
      partialSubtypeCheckVsZeroNode *node = new partialSubtypeCheckVsZeroNode();
      return node;
    }
  case string_compareU_rule: {
      string_compareUNode *node = new string_compareUNode();
      return node;
    }
  case string_compareL_rule: {
      string_compareLNode *node = new string_compareLNode();
      return node;
    }
  case string_compareUL_rule: {
      string_compareULNode *node = new string_compareULNode();
      return node;
    }
  case string_compareLU_rule: {
      string_compareLUNode *node = new string_compareLUNode();
      return node;
    }
  case string_indexofUU_rule: {
      string_indexofUUNode *node = new string_indexofUUNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(10, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(11, MachOperGenerator(VREGD_V0));
      node->set_opnd_array(12, MachOperGenerator(VREGD_V1));
      return node;
    }
  case string_indexofLL_rule: {
      string_indexofLLNode *node = new string_indexofLLNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(10, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(11, MachOperGenerator(VREGD_V0));
      node->set_opnd_array(12, MachOperGenerator(VREGD_V1));
      return node;
    }
  case string_indexofUL_rule: {
      string_indexofULNode *node = new string_indexofULNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(10, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(11, MachOperGenerator(VREGD_V0));
      node->set_opnd_array(12, MachOperGenerator(VREGD_V1));
      return node;
    }
  case string_indexof_conUU_rule: {
      string_indexof_conUUNode *node = new string_indexof_conUUNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexof_conLL_rule: {
      string_indexof_conLLNode *node = new string_indexof_conLLNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexof_conUL_rule: {
      string_indexof_conULNode *node = new string_indexof_conULNode();
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexofU_char_rule: {
      string_indexofU_charNode *node = new string_indexofU_charNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_equalsL_rule: {
      string_equalsLNode *node = new string_equalsLNode();
      return node;
    }
  case string_equalsU_rule: {
      string_equalsUNode *node = new string_equalsUNode();
      return node;
    }
  case array_equalsB_rule: {
      array_equalsBNode *node = new array_equalsBNode();
      node->set_opnd_array(3, MachOperGenerator(IREGP_R3));
      node->set_opnd_array(4, MachOperGenerator(IREGP_R4));
      node->set_opnd_array(5, MachOperGenerator(IREGP_R5));
      node->set_opnd_array(6, MachOperGenerator(VREGD_V0));
      node->set_opnd_array(7, MachOperGenerator(VREGD_V1));
      node->set_opnd_array(8, MachOperGenerator(VREGD_V2));
      node->set_opnd_array(9, MachOperGenerator(VREGD_V3));
      node->set_opnd_array(10, MachOperGenerator(VREGD_V4));
      node->set_opnd_array(11, MachOperGenerator(VREGD_V5));
      node->set_opnd_array(12, MachOperGenerator(VREGD_V6));
      node->set_opnd_array(13, MachOperGenerator(VREGD_V7));
      return node;
    }
  case array_equalsC_rule: {
      array_equalsCNode *node = new array_equalsCNode();
      node->set_opnd_array(3, MachOperGenerator(IREGP_R3));
      node->set_opnd_array(4, MachOperGenerator(IREGP_R4));
      node->set_opnd_array(5, MachOperGenerator(IREGP_R5));
      node->set_opnd_array(6, MachOperGenerator(VREGD_V0));
      node->set_opnd_array(7, MachOperGenerator(VREGD_V1));
      node->set_opnd_array(8, MachOperGenerator(VREGD_V2));
      node->set_opnd_array(9, MachOperGenerator(VREGD_V3));
      node->set_opnd_array(10, MachOperGenerator(VREGD_V4));
      node->set_opnd_array(11, MachOperGenerator(VREGD_V5));
      node->set_opnd_array(12, MachOperGenerator(VREGD_V6));
      node->set_opnd_array(13, MachOperGenerator(VREGD_V7));
      return node;
    }
  case has_negatives_rule: {
      has_negativesNode *node = new has_negativesNode();
      return node;
    }
  case string_compress_rule: {
      string_compressNode *node = new string_compressNode();
      node->set_opnd_array(4, MachOperGenerator(VREGD_V0));
      node->set_opnd_array(5, MachOperGenerator(VREGD_V1));
      node->set_opnd_array(6, MachOperGenerator(VREGD_V2));
      node->set_opnd_array(7, MachOperGenerator(VREGD_V3));
      node->set_opnd_array(8, MachOperGenerator(VREGD_V4));
      node->set_opnd_array(9, MachOperGenerator(VREGD_V5));
      return node;
    }
  case string_inflate_rule: {
      string_inflateNode *node = new string_inflateNode();
      node->set_opnd_array(4, MachOperGenerator(IREGP_R3));
      node->set_opnd_array(5, MachOperGenerator(VREGD_V0));
      node->set_opnd_array(6, MachOperGenerator(VREGD_V1));
      node->set_opnd_array(7, MachOperGenerator(VREGD_V2));
      node->set_opnd_array(8, MachOperGenerator(VREGD_V3));
      node->set_opnd_array(9, MachOperGenerator(VREGD_V4));
      node->set_opnd_array(10, MachOperGenerator(VREGD_V5));
      node->set_opnd_array(11, MachOperGenerator(VREGD_V6));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encode_iso_array_rule: {
      encode_iso_arrayNode *node = new encode_iso_arrayNode();
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new tlsLoadPNode();
      return node;
    }
  case loadV4_rule: {
      loadV4Node *node = new loadV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV8_rule: {
      loadV8Node *node = new loadV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV16_rule: {
      loadV16Node *node = new loadV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV4_rule: {
      storeV4Node *node = new storeV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV8_rule: {
      storeV8Node *node = new storeV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV16_rule: {
      storeV16Node *node = new storeV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8B_rule: {
      replicate8BNode *node = new replicate8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate16B_rule: {
      replicate16BNode *node = new replicate16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8B_imm_rule: {
      replicate8B_immNode *node = new replicate8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate16B_imm_rule: {
      replicate16B_immNode *node = new replicate16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4S_rule: {
      replicate4SNode *node = new replicate4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8S_rule: {
      replicate8SNode *node = new replicate8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4S_imm_rule: {
      replicate4S_immNode *node = new replicate4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate8S_imm_rule: {
      replicate8S_immNode *node = new replicate8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2I_rule: {
      replicate2INode *node = new replicate2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4I_rule: {
      replicate4INode *node = new replicate4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2I_imm_rule: {
      replicate2I_immNode *node = new replicate2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4I_imm_rule: {
      replicate4I_immNode *node = new replicate4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2L_rule: {
      replicate2LNode *node = new replicate2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2L_zero_rule: {
      replicate2L_zeroNode *node = new replicate2L_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2F_rule: {
      replicate2FNode *node = new replicate2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate4F_rule: {
      replicate4FNode *node = new replicate4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicate2D_rule: {
      replicate2DNode *node = new replicate2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add2I_rule: {
      reduce_add2INode *node = new reduce_add2INode();
      node->set_opnd_array(3, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add4I_rule: {
      reduce_add4INode *node = new reduce_add4INode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul2I_rule: {
      reduce_mul2INode *node = new reduce_mul2INode();
      node->set_opnd_array(3, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul4I_rule: {
      reduce_mul4INode *node = new reduce_mul4INode();
      node->set_opnd_array(3, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add2F_rule: {
      reduce_add2FNode *node = new reduce_add2FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add4F_rule: {
      reduce_add4FNode *node = new reduce_add4FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul2F_rule: {
      reduce_mul2FNode *node = new reduce_mul2FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul4F_rule: {
      reduce_mul4FNode *node = new reduce_mul4FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add2D_rule: {
      reduce_add2DNode *node = new reduce_add2DNode();
      node->set_opnd_array(3, MachOperGenerator(VREGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul2D_rule: {
      reduce_mul2DNode *node = new reduce_mul2DNode();
      node->set_opnd_array(3, MachOperGenerator(VREGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max2F_rule: {
      reduce_max2FNode *node = new reduce_max2FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max4F_rule: {
      reduce_max4FNode *node = new reduce_max4FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max2D_rule: {
      reduce_max2DNode *node = new reduce_max2DNode();
      node->set_opnd_array(3, MachOperGenerator(VREGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min2F_rule: {
      reduce_min2FNode *node = new reduce_min2FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->set_opnd_array(4, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min4F_rule: {
      reduce_min4FNode *node = new reduce_min4FNode();
      node->set_opnd_array(3, MachOperGenerator(VREGF));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min2D_rule: {
      reduce_min2DNode *node = new reduce_min2DNode();
      node->set_opnd_array(3, MachOperGenerator(VREGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_rule: {
      vadd8BNode *node = new vadd8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_rule: {
      vadd16BNode *node = new vadd16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_rule: {
      vadd4SNode *node = new vadd4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_rule: {
      vadd8SNode *node = new vadd8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_rule: {
      vadd2INode *node = new vadd2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_rule: {
      vadd4INode *node = new vadd4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_rule: {
      vadd2LNode *node = new vadd2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_rule: {
      vadd2FNode *node = new vadd2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_rule: {
      vadd4FNode *node = new vadd4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_rule: {
      vadd2DNode *node = new vadd2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8B_rule: {
      vsub8BNode *node = new vsub8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_rule: {
      vsub16BNode *node = new vsub16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4S_rule: {
      vsub4SNode *node = new vsub4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_rule: {
      vsub8SNode *node = new vsub8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2I_rule: {
      vsub2INode *node = new vsub2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_rule: {
      vsub4INode *node = new vsub4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_rule: {
      vsub2LNode *node = new vsub2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_rule: {
      vsub2FNode *node = new vsub2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_rule: {
      vsub4FNode *node = new vsub4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_rule: {
      vsub2DNode *node = new vsub2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8B_rule: {
      vmul8BNode *node = new vmul8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16B_rule: {
      vmul16BNode *node = new vmul16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_rule: {
      vmul4SNode *node = new vmul4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_rule: {
      vmul8SNode *node = new vmul8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_rule: {
      vmul2INode *node = new vmul2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_rule: {
      vmul4INode *node = new vmul4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_rule: {
      vmul2FNode *node = new vmul2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_rule: {
      vmul4FNode *node = new vmul4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_rule: {
      vmul2DNode *node = new vmul2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla4S_rule: {
      vmla4SNode *node = new vmla4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla4S_0_rule: {
      vmla4S_0Node *node = new vmla4S_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla8S_rule: {
      vmla8SNode *node = new vmla8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla8S_0_rule: {
      vmla8S_0Node *node = new vmla8S_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla2I_rule: {
      vmla2INode *node = new vmla2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla2I_0_rule: {
      vmla2I_0Node *node = new vmla2I_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla4I_rule: {
      vmla4INode *node = new vmla4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla4I_0_rule: {
      vmla4I_0Node *node = new vmla4I_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla2F_rule: {
      vmla2FNode *node = new vmla2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla4F_rule: {
      vmla4FNode *node = new vmla4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmla2D_rule: {
      vmla2DNode *node = new vmla2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls4S_rule: {
      vmls4SNode *node = new vmls4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls8S_rule: {
      vmls8SNode *node = new vmls8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls2I_rule: {
      vmls2INode *node = new vmls2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls4I_rule: {
      vmls4INode *node = new vmls4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls2F_rule: {
      vmls2FNode *node = new vmls2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls2F_0_rule: {
      vmls2F_0Node *node = new vmls2F_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls4F_rule: {
      vmls4FNode *node = new vmls4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls4F_0_rule: {
      vmls4F_0Node *node = new vmls4F_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls2D_rule: {
      vmls2DNode *node = new vmls2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmls2D_0_rule: {
      vmls2D_0Node *node = new vmls2D_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2F_rule: {
      vdiv2FNode *node = new vdiv2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_rule: {
      vdiv4FNode *node = new vdiv4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_rule: {
      vdiv2DNode *node = new vdiv2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt2F_rule: {
      vsqrt2FNode *node = new vsqrt2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt4F_rule: {
      vsqrt4FNode *node = new vsqrt4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrt2D_rule: {
      vsqrt2DNode *node = new vsqrt2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs8B_rule: {
      vabs8BNode *node = new vabs8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs16B_rule: {
      vabs16BNode *node = new vabs16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs4S_rule: {
      vabs4SNode *node = new vabs4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs8S_rule: {
      vabs8SNode *node = new vabs8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs2I_rule: {
      vabs2INode *node = new vabs2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs4I_rule: {
      vabs4INode *node = new vabs4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs2L_rule: {
      vabs2LNode *node = new vabs2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs2F_rule: {
      vabs2FNode *node = new vabs2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs4F_rule: {
      vabs4FNode *node = new vabs4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabs2D_rule: {
      vabs2DNode *node = new vabs2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vneg2F_rule: {
      vneg2FNode *node = new vneg2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vneg4F_rule: {
      vneg4FNode *node = new vneg4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vneg2D_rule: {
      vneg2DNode *node = new vneg2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_rule: {
      vand8BNode *node = new vand8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_rule: {
      vand16BNode *node = new vand16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_rule: {
      vor8BNode *node = new vor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_rule: {
      vor16BNode *node = new vor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_rule: {
      vxor8BNode *node = new vxor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_rule: {
      vxor16BNode *node = new vxor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt8B_rule: {
      vshiftcnt8BNode *node = new vshiftcnt8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt8B_0_rule: {
      vshiftcnt8B_0Node *node = new vshiftcnt8B_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt16B_rule: {
      vshiftcnt16BNode *node = new vshiftcnt16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt16B_0_rule: {
      vshiftcnt16B_0Node *node = new vshiftcnt16B_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8B_rule: {
      vsll8BNode *node = new vsll8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16B_rule: {
      vsll16BNode *node = new vsll16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8B_rule: {
      vsra8BNode *node = new vsra8BNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16B_rule: {
      vsra16BNode *node = new vsra16BNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8B_rule: {
      vsrl8BNode *node = new vsrl8BNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16B_rule: {
      vsrl16BNode *node = new vsrl16BNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8B_imm_rule: {
      vsll8B_immNode *node = new vsll8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16B_imm_rule: {
      vsll16B_immNode *node = new vsll16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8B_imm_rule: {
      vsra8B_immNode *node = new vsra8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16B_imm_rule: {
      vsra16B_immNode *node = new vsra16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8B_imm_rule: {
      vsrl8B_immNode *node = new vsrl8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16B_imm_rule: {
      vsrl16B_immNode *node = new vsrl16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_rule: {
      vsll4SNode *node = new vsll4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_rule: {
      vsll8SNode *node = new vsll8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_rule: {
      vsra4SNode *node = new vsra4SNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_rule: {
      vsra8SNode *node = new vsra8SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_rule: {
      vsrl4SNode *node = new vsrl4SNode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_rule: {
      vsrl8SNode *node = new vsrl8SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_imm_rule: {
      vsll4S_immNode *node = new vsll4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_imm_rule: {
      vsll8S_immNode *node = new vsll8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_imm_rule: {
      vsra4S_immNode *node = new vsra4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_imm_rule: {
      vsra8S_immNode *node = new vsra8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_imm_rule: {
      vsrl4S_immNode *node = new vsrl4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_imm_rule: {
      vsrl8S_immNode *node = new vsrl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_rule: {
      vsll2INode *node = new vsll2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_rule: {
      vsll4INode *node = new vsll4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_rule: {
      vsra2INode *node = new vsra2INode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_rule: {
      vsra4INode *node = new vsra4INode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_rule: {
      vsrl2INode *node = new vsrl2INode();
      node->set_opnd_array(3, MachOperGenerator(VECD));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_rule: {
      vsrl4INode *node = new vsrl4INode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_imm_rule: {
      vsll2I_immNode *node = new vsll2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_imm_rule: {
      vsll4I_immNode *node = new vsll4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_imm_rule: {
      vsra2I_immNode *node = new vsra2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_imm_rule: {
      vsra4I_immNode *node = new vsra4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_imm_rule: {
      vsrl2I_immNode *node = new vsrl2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_imm_rule: {
      vsrl4I_immNode *node = new vsrl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_rule: {
      vsll2LNode *node = new vsll2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2L_rule: {
      vsra2LNode *node = new vsra2LNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_rule: {
      vsrl2LNode *node = new vsrl2LNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_imm_rule: {
      vsll2L_immNode *node = new vsll2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2L_imm_rule: {
      vsra2L_immNode *node = new vsra2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_imm_rule: {
      vsrl2L_immNode *node = new vsrl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmax2F_rule: {
      vmax2FNode *node = new vmax2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmax4F_rule: {
      vmax4FNode *node = new vmax4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmax2D_rule: {
      vmax2DNode *node = new vmax2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmin2F_rule: {
      vmin2FNode *node = new vmin2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmin4F_rule: {
      vmin4FNode *node = new vmin4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmin2D_rule: {
      vmin2DNode *node = new vmin2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vpopcount4I_rule: {
      vpopcount4INode *node = new vpopcount4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vpopcount2I_rule: {
      vpopcount2INode *node = new vpopcount2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndSwapP_shenandoah_rule: {
      compareAndSwapP_shenandoahNode *node = new compareAndSwapP_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case compareAndSwapN_shenandoah_rule: {
      compareAndSwapN_shenandoahNode *node = new compareAndSwapN_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      return node;
    }
  case compareAndSwapPAcq_shenandoah_rule: {
      compareAndSwapPAcq_shenandoahNode *node = new compareAndSwapPAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case compareAndSwapNAcq_shenandoah_rule: {
      compareAndSwapNAcq_shenandoahNode *node = new compareAndSwapNAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      return node;
    }
  case compareAndExchangeN_shenandoah_rule: {
      compareAndExchangeN_shenandoahNode *node = new compareAndExchangeN_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGNNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeP_shenandoah_rule: {
      compareAndExchangeP_shenandoahNode *node = new compareAndExchangeP_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case weakCompareAndSwapN_shenandoah_rule: {
      weakCompareAndSwapN_shenandoahNode *node = new weakCompareAndSwapN_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      return node;
    }
  case weakCompareAndSwapP_shenandoah_rule: {
      weakCompareAndSwapP_shenandoahNode *node = new weakCompareAndSwapP_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAARCH64=1
#ifndef AARCH64
#  error "AARCH64 must be defined"
#endif // AARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
